<?php 
namespace App\Http\Controllers;
    
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\Fabric;
use App\Models\Pattern;
use App\Models\Wash_Code;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use Spatie\Permission\Traits\HasRoles;
use Mail;
use DataTables;
use App\Models\Item;
use Auth;

class FabricController extends Controller
{
    public function index()
    {   
    	$foam = Fabric::orderBy('id','DESC')->get();
        return view('pages.fabric.index',compact('foam'));
    }

    public function dealfabric()
    {   
        // $foam = Fabric::orderBy('id','DESC')->get();
        return view('pages.fabric.dealer');
    }

    public function deal_fabric(Request $request)
    {
        
        if ($request->ajax()) {
             $foam = Item::where('item_cat_id',1)->get();

           
            return Datatables::of($foam)
                ->addIndexColumn()
                ->addColumn('action', function($foam){
                    $order_schedule_html = '<button class="schduled_date" data-id="'.base64_encode($foam->id).'"><i class="fa fa-eye"></i> </button>';
                     return $order_schedule_html;
                    
                    })
                ->addColumn('name', function($foam){
                    return $foam->name;
                })
                ->addColumn('quantity_available', function($foam){
                    return $foam->quantity_available;
                })
                ->addColumn('fabric_content', function($foam){
                    return $foam->fabric_content;
                })
                ->addColumn('is_available', function($foam){
                    $foam_avl = "Yes";
                    if($foam->is_available == '0'){
                        $foam_avl = "No";
                    }
                    return $foam_avl;
                })
                ->rawColumns(['action','is_available'])
                ->make(true);
        }
        
        return view('pages.fabric.dealer');
    }

    public function create()
    {
        return view('pages.fabric.create');
    }

    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'       => 'required',
            'price'      => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $dealer = new Fabric;
        $dealer->name   = $request->name;
        $dealer->price  = $request->price;
        $dealer->save();
        return redirect('fabric')->with('message', 'Fabric grade created successfully');
    }

    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function FabDetails($id)
    {
        $id = base64_decode($id);
        $item           = Item::find($id);
        $fab_grade      = Fabric::find($item->fabric_grade_id);
        $patten         = Pattern::find($item->patten_id);
        $wash_code      = Wash_Code::find($item->wash_code_id);
        $supplier       = User::find($item->supplier_id);
        return view('pages.fabric.fab-detail',compact('item','fab_grade','supplier','patten','wash_code'));
    }

    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */
    public function edit($id)
    {
        $dealer = Fabric::find($id);
        return view('pages.fabric.edit',compact('dealer'));
    }

    /**
        * Update the specified resource in storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function update(Request $request, $id)
    {
            $validator = Validator::make($request->all(), [
                'name'       => 'required',
                'price'            => 'required',
            ]);
        

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $dealer = Fabric::find($id);
        $dealer->name = $request->name;
        $dealer->price  = $request->price;
        $dealer->save();
        return redirect('fabric')->with('message', 'Fabric grade updated successfully');
    }

    /**
        * Remove the specified resource from storage.
        *
        * @param  int  $id
        * @return Response
        */
    public function destroy($id)
    {
        $dealer = Fabric::find($id);
        $dealer->delete();
        return redirect('fabric')->with('message', 'Fabric grade deleted successfully');
    }

}