<?php 
namespace App\Http\Controllers;
    
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\Foam_Style;
use App\Models\Fabric;
use App\Models\Order_Inventory;
use App\Models\Stock_History;
use App\Models\Item;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use Spatie\Permission\Traits\HasRoles;
use Mail;
use DataTables;
use Auth;

class Fabric_Inv_Controller extends Controller
{
    public function index()
    {   
      $foam = Foam_Style::orderBy('id','DESC')->get();

      $fabric = Order_Inventory::join('item','order_inventory.item_id','=','item.id')->join('users','order_inventory.supplier_id','=','users.id')->select('order_inventory.*','item.name','item.image','item.quantity_available','users.first_name','users.last_name','order_inventory.id')->orderBy('order_inventory.id','desc')->get();


      foreach($fabric as $fab){
        $fab->order_rec = Stock_History::where('order_inv_id',$fab->id)->sum('stock_added');
      }

      //return $fabric;
       return view('pages.inventory.fabric.index',compact('fabric'));
    }

    public function fullfab($uid)
    { 
 
      $order_inv = Order_Inventory::find($uid);

      if($order_inv){

          $item = Item::find($order_inv->item_id);
          $stock = Stock_History::where('order_inv_id',$order_inv->id)->first();
           $type = "Add Order Fabric Inventory Partial";
          if($stock){

            $stock_req = $order_inv->yard_req - $stock->stock_added; 
            $this->addFab($item->id,$order_inv->id,$type,$stock_req);
          } else {
            $type = "Add Order Fabric Inventory Full";
            $this->addFab($item->id,$order_inv->id,$type,$order_inv->yard_req);
          }

            $order_inv->status = 2;
            $order_inv->save();
       

       

      }

      return redirect('dealer/orders/fabric');

    }

    public function partialfab(Request $request)
    { 
        //return $request;

      $order_inv = Order_Inventory::find($request->item_id);

      if($order_inv && $order_inv->yard_req >= $request->fab_received &&  $request->fab_received >0){

        $order_inv->status = 1;
        if($order_inv->yard_req == $request->fab_received){
          $order_inv->status = 2;
        }
        
        $order_inv->save();

          $item = Item::find($order_inv->item_id);
          $type = "Add Order Fabric Inventory Partial";
       $this->addFab($item->id,$order_inv->id,$type,$request->fab_received);

       

      }

      return redirect('dealer/orders/fabric');

    }

    public function store(Request $request)
    {   
      //return $request;


      $order_inv = new Order_Inventory();
      $order_inv->user_id = Auth::user()->id;
      $order_inv->cat_id = $request->item_cat_id;
      $order_inv->status = 0;
      $order_inv->item_id = $request->fabric_order;
      $order_inv->supplier_id = $request->supplier_id;
      $order_inv->yard_req = $request->yard_required;
      $order_inv->description = $request->order_description;
      $order_inv->save();

      
       return redirect('dealer/orders/fabric');
    }

    public function create()
    {   
      $fabric = Item::where('item_cat_id',1)->join('fabric_grade','fabric_grade.id','=','item.fabric_grade_id')->join('wash_code','wash_code.id','=','item.wash_code_id')->join('patten','patten.id','=','item.patten_id')->join('users','users.id','=','item.supplier_id')->select('item.*','fabric_grade.name as grade','fabric_grade.price','users.first_name','users.last_name','item.id','wash_code.name as washcode','patten.name as pettern')->orderBy('item.name','ASC')->Where('is_available','0')->get();

       //return $fabric;
       return view('pages.inventory.fabric.create',compact('fabric'));
    }


     function addFab($fab_id,$order_det_id,$type,$yard_add){

        $item = Item::where('id',$fab_id)->first();
        if($item){
        
        // stock history
            $stock =new  Stock_History;
            $stock->item_id = $fab_id;
            $stock->order_inv_id = $order_det_id;
            $stock->type = $type;
            $stock->stock_added = $yard_add;
            $stock->user_id = Auth::user()->id;
            $stock->stock_avl = $item->quantity_available;
            $stock->total_avl = $item->quantity_available + $yard_add;
            $stock->save();

             $item->quantity_available = $item->quantity_available + $yard_add;
             $item->save();

         }
    }


     function deductFab($fab_id,$order_det_id,$type,$yard_ded){

        $item = Item::where('id',$fab_id)->first();
        if($item){
        
        // stock history
        $stock =new  Stock_History;
        $stock->item_id = $item->id;
        $stock->order_inv_id = $order_det_id;
        $stock->type = $type;
        $stock->stock_removed = $yard_ded;
        $stock->user_id = Auth::user()->id;
        $stock->stock_avl = $item->quantity_available;
        $stock->total_avl = $item->quantity_available - $yard_ded;
        $stock->save();

        // stock item
        $item->quantity_available = $item->quantity_available - $yard_ded;
        $item->save();

         }
    }

}