<?php 
namespace App\Http\Controllers;
    
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\Item;
use App\Models\Pattern;
use App\Models\Legs_Grade;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use Spatie\Permission\Traits\HasRoles;
use Mail;
use DataTables;
use Auth;

class IPillowController extends Controller
{
    public function index()
    {   
        $item = Item::where('item_cat_id',6)->orderBy('id','DESC')->get();
       return view('pages.item.pillow.index',compact('item'));;
    }

    public function create()
    {
        $suppliers = User::join('model_has_roles','users.id','=','model_has_roles.model_id')->where('model_has_roles.role_id',4)->OrderBy('users.id','DESC')->select('*','users.id as uid')->get();
        return view('pages.item.pillow.create',compact('suppliers'));
    }

    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'                  => 'required',
            'ion_number'            => 'required',
            //'quantity_available'    => 'required',
            'is_available'          => 'required',
            'supplier_id'           => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }
                                                      
        $legs = new Item;
        $legs->name         = $request->name;
        $legs->ion_number   = $request->ion_number;
        $legs->item_cat_id  = 6;
        $legs->notes        = $request->notes;
        if($request->is_available == 'yes'){
            $legs->quantity_available  = $request->quantity_available; 
        }
        $legs->is_available        = $request->is_available;
        $legs->supplier_id         = $request->supplier_id;
        //upload image
        if($request->hasfile('image'))
        {
            $image = $request->file('image');
            $name  = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/item/fabric/');
            $image->move($destinationPath, $name);
            $legs->image   = $name;
        }
        $legs->save();
        returnredirect('ipillows')->with('message', 'Pillow created successfully');
    }

    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function show($id)
    {
        //
    }

    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */
    public function edit($id)
    {
        $dealer = Item::find($id);
        

         $suppliers = User::join('model_has_roles','users.id','=','model_has_roles.model_id')->where('model_has_roles.role_id',4)->OrderBy('users.id','DESC')->select('*','users.id as uid')->get();
        return view('pages.item.pillow.edit',compact('dealer','suppliers'));
    }

    /**
        * Update the specified resource in storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'name'                  => 'required',
            'ion_number'            => 'required',
            //'quantity_available'    => 'required',
            'is_available'          => 'required',
            'supplier_id'           => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $legs = Item::find($id);
        $legs->name        = $request->name;
        $legs->ion_number  = $request->ion_number;
        $legs->notes       = $request->notes;
        if($request->is_available == 'yes'){
            $legs->quantity_available  = $request->quantity_available; 
        }else{
            $legs->quantity_available  = "";
        }
        $legs->is_available = $request->is_available;
        $legs->supplier_id  = $request->supplier_id;
        if($request->hasfile('image'))
        {
            $image = $request->file('image');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/item/fabric/');
            $image->move($destinationPath, $name);
            $legs->image = $name;
        }
        $legs->save();
        returnredirect('ipillows')->with('message', 'Pillow updated successfully');
    }

    /**
        * Remove the specified resource from storage.
        *
        * @param  int  $id
        * @return Response
        */
    public function destroy($id)
    {
        $dealer = Item::find($id);
        $dealer->delete();
        return redirect('ipillows')->with('message', 'Pillow deleted successfully');
    }



}