<?php 
namespace App\Http\Controllers;
    
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\Item;
use App\Models\Pattern;
use App\Models\Legs_Grade;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use Spatie\Permission\Traits\HasRoles;
use Mail;
use DataTables;
use Auth;

class MechanismController extends Controller
{
    public function index()
    {   
        $item = Item::where('item_cat_id',5)->orderBy('id','DESC')->get();
       return view('pages.item.mechanism.index',compact('item'));;
    }

    public function create()
    {
       
         $suppliers = User::join('model_has_roles','users.id','=','model_has_roles.model_id')->where('model_has_roles.role_id',4)->OrderBy('users.first_name','ASC')->select('*','users.id as uid')->get();
        return view('pages.item.mechanism.create',compact('suppliers'));
    }

    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'         => 'required',
            'supplier'  => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }
                                                      
        $mechanism = new Item;
        $mechanism->name = $request->name;
        $mechanism->item_cat_id  = 5;
        $mechanism->supplier_id  = $request->supplier;
        $mechanism->ion_number       = $request->ion_number;
        $mechanism->notes       = $request->notes;
        if($request->is_available == 'yes'){
            $mechanism->quantity_available  = $request->quantity_available; 
        }else{
            $mechanism->quantity_available  = "";
        }
        $mechanism->is_available  = $request->is_available;
        $mechanism->save();
        return redirect('mechanism')->with('message', 'Mechanism added successfully');
    }

    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function show($id)
    {
        //
    }

    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */
    public function edit($id)
    {
        $dealer    = Item::find($id);
        $suppliers = User::join('model_has_roles','users.id','=','model_has_roles.model_id')->where('model_has_roles.role_id',4)->OrderBy('users.first_name','ASC')->select('*','users.id as uid')->get();
        return view('pages.item.mechanism.edit',compact('dealer','suppliers'));
    }

    /**
        * Update the specified resource in storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'name'       => 'required',
            'supplier'   => 'required',
        ]);
        
        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $mechanism = Item::find($id);
        $mechanism->name = $request->name;
        $mechanism->supplier_id  = $request->supplier;  
        $mechanism->ion_number       = $request->ion_number;        
        $mechanism->notes       = $request->notes;
        if($request->is_available == 'yes'){
            $mechanism->quantity_available  = $request->quantity_available; 
        }else{
            $mechanism->quantity_available  = "";
        } 
        $mechanism->is_available  = $request->is_available;
        $mechanism->save();
        return redirect('mechanism')->with('message', 'Mechanism updated successfully');
    }

    /**
        * Remove the specified resource from storage.
        *
        * @param  int  $id
        * @return Response
        */
    public function destroy($id)
    {
        $item = Item::find($id);
        $item->delete();
        return redirect('mechanism')->with('message', 'Mechanism deleted successfully');
    }



}