<?php 
namespace App\Http\Controllers;
    
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\Item;
use App\Models\Pattern;
use App\Models\Legs_Grade;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use Spatie\Permission\Traits\HasRoles;
use Mail;
use DataTables;
use Auth;

class NailHeadController extends Controller
{
    public function index()
    {   
        $item = Item::where('item_cat_id',4)->orderBy('id','DESC')->get();
       return view('pages.item.nailhead.index',compact('item'));;
    }

    public function create()
    {
       
         $suppliers = User::join('model_has_roles','users.id','=','model_has_roles.model_id')->where('model_has_roles.role_id',4)->OrderBy('users.first_name','ASC')->select('*','users.id as uid')->get();
        return view('pages.item.nailhead.create',compact('suppliers'));
    }

    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'       => 'required',
            'ion_number'            => 'required',
            //'quantity_available'       => 'required',
            'is_available'            => 'required',
            'supplier_id'       => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }
                                                      
        $item = new Item;
        $item->name = $request->name;
        $item->ion_number  = $request->ion_number;
        $item->item_cat_id  = 4;
        $item->supplier_id  = $request->supplier_id;
        $item->notes        = $request->notes;
        if($request->is_available == 'yes'){
            $item->quantity_available  = $request->quantity_available; 
        }
        $item->is_available  = $request->is_available;
        //upload image
        if($request->hasfile('image'))
        {
            $image = $request->file('image');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/item/fabric/');
            $image->move($destinationPath, $name);
            $item->image = $name;
        }
        $item->save();

        return redirect('nail-head')->with('message', 'NailHead created successfully');
    }

    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function show($id)
    {
        //
    }

    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */
    public function edit($id)
    {
        $dealer = Item::find($id);
        

         $suppliers = User::join('model_has_roles','users.id','=','model_has_roles.model_id')->where('model_has_roles.role_id',4)->OrderBy('users.first_name','ASC')->select('*','users.id as uid')->get();
        return view('pages.item.nailhead.edit',compact('dealer','suppliers'));
    }

    /**
        * Update the specified resource in storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function update(Request $request, $id)
    {
            $validator = Validator::make($request->all(), [
                'name'       => 'required',
                'ion_number'            => 'required',
            ]);
        

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $item = Item::find($id);
        $item->name         = $request->name;
        $item->ion_number   = $request->ion_number;
        $item->supplier_id  = $request->supplier_id;
        $item->notes        = $request->notes;
        if($request->is_available == 'yes'){
            $item->quantity_available  = $request->quantity_available; 
        }else{
            $item->quantity_available  = "";
        }
        $item->is_available = $request->is_available;
        if($request->hasfile('image'))
        {
            $image = $request->file('image');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/item/fabric/');
            $image->move($destinationPath, $name);
            $item->image    = $name;
        }
        $item->save();
        return redirect('nail-head')->with('message', 'NailHead updated successfully');
    }

    /**
        * Remove the specified resource from storage.
        *
        * @param  int  $id
        * @return Response
        */
    public function destroy($id)
    {
        $dealer = Item::find($id);
        $dealer->delete();
        return redirect('nail-head')->with('message', 'NailHead deleted successfully');
    }



}