<?php 

namespace App\Http\Controllers;
use App\DataTables\UsersDataTable;
use Illuminate\Routing\UrlGenerator;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Response;
use App\Models\Stock_History;
use App\Models\ProductCategory;
use App\Models\Product;
use App\Models\Foam_Style;
use App\Models\Order;
use App\Models\Order_Item;
use App\Models\Item;
use App\Models\Foam_Grade;
use Spatie\Permission\Models\Role;
use Session;
use Auth;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use DataTables;
use App\Models\{Country,State,City};
//cart
use Overtrue\LaravelShoppingCart\Cart;
use Mail;
use Carbon;
use DateTime;
use Illuminate\Support\Str;

class OrderController extends Controller
{ 
    protected $cart;

    protected $url;

    public function __construct(UrlGenerator $url)
    {

        $this->url = $url;

  }


    // public function index()
    // {   
    //     $orders = Order::where('orders.status',1)->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->select('order_items.id as order_det_id','orders.id as order_id','orders.user_id as user_id','order_items.total_price as total_price','orders.po_number as po_number','order_items.status as status','order_items.order_date','products.name','item.name as fabric_name','orders.billing_address','orders.billing_city','orders.billing_provience','orders.billing_country','orders.billing_pincode','orders.shipping_address','orders.shipping_city','orders.shipping_provience','orders.shipping_country','orders.shipping_pincode','order_items.*')->orderBy('order_items.id', "desc")->get();

    //       $dealers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',3)->OrderBy('users.first_name','ASC')->get();

    //       $prod_cat = ProductCategory::orderBy('name','ASC')->get();


    //     return view('pages.orders.index',compact('orders','dealers','prod_cat'));
    // }

    public function getOrders(Request $request)
    {
        if ($request->ajax()) {
            $data = User::latest()->get();
            return Datatables::of($data)
                ->addIndexColumn()
                ->addColumn('action', function($row){
                    $actionBtn = '<a href="javascript:void(0)" class="edit btn btn-success btn-sm">Edit</a> <a href="javascript:void(0)" class="delete btn btn-danger btn-sm">Delete</a>';
                    return $actionBtn;
                })
                ->rawColumns(['action'])
                ->make(true);
        }
    }

    public function dealerOrder(Request $request)
    {   
   
        

            if ($request->ajax()) {
            $orders = $orders = Order::where('orders.status',1)->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->select('order_items.id as order_det_id','orders.id as order_id','orders.user_id as user_id','order_items.total_price as total_price','orders.po_number as po_number','order_items.status as status','order_items.order_date','products.name')->orderBy('order_items.id', "desc")->where('orders.user_id',Auth::user()->id)->get();

           
            return Datatables::of($orders)
                ->addIndexColumn()
                ->addColumn('action', function($orders){
                    // $order_schedule_html = '<button class="schduled_date" data-id="'.base64_encode($orders->id).'"><i class="fa fa-eye"></i> </button>';
                    //  return $order_schedule_html;

                    $path = $this->url->to('/dealer/orders-details').'/'.base64_encode($orders->order_id).'/'.base64_encode($orders->order_det_id);

                   $view =' <div class="menu-item px-3">
                                        <a href="'.$path.'" class="menu-link px-3"><i class="fa fa-eye"></i></a>
                                    </div>';

                    return $view;
                    
                    })
                ->addColumn('po_number', function($orders){
                    return $orders->po_number;
                })
                ->addColumn('order_date', function($orders){
                    return $orders->order_date;
                })
                ->addColumn('product_name', function($orders){
                    return $orders->name;
                })
                ->addColumn('status', function($orders){
                            if($orders->status ==0){
                                  $statu = "Back Order";
                                }elseif($orders->status ==1){
                               $statu = "Order Received";
                                }elseif($orders->status ==2){
                               $statu = "Manufacturing";
                                }elseif($orders->status ==3){
                               $statu = "Ready To Ship";
                                }elseif($orders->status == 4){
                               $statu = "Shipped";
                                } else {
                                $statu = "Cancelled";   
                                }

                    return $statu;
                })
                ->rawColumns(['action','status'])
                ->make(true);
        }
         return view('pages.orders.dealer-index');

    }

    public function dealerOrderview($order_id,$item_id)
    {   
   
         $order_id    = base64_decode($order_id);
        $item_id     = base64_decode($item_id);
        $order_item  = Order_Item::where('id',$item_id)->first();
        $order       = Order::where('id',$order_id)->first();
        $user        = User::where('id',$order->user_id)->first();
        return view('pages.orders.show-details',compact( 'order_item','order','user' ));

    }
    public function orderbyDate(Request $request)
    {   
        //return $request;
        $order = Order::where('orders.status',1)->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->select('order_items.id as order_det_id','orders.id as order_id','orders.user_id as user_id','order_items.total_price as total_price','orders.po_number as po_number','order_items.status as status','order_items.order_date','products.name','item.name as fabric_name','orders.billing_address','orders.billing_city','orders.billing_provience','orders.billing_country','orders.billing_pincode','orders.shipping_address','orders.shipping_city','orders.shipping_provience','orders.shipping_country','orders.shipping_pincode','order_items.*')->orderBy('order_items.id','DESC');

        if($request->has('from_date') && $request->has('to_date') && $request->date_type == 1){
        $order->whereBetween('order_date', [$request->from_date, $request->to_date]);
            }

        if($request->has('from_date') && $request->has('to_date') && $request->date_type == 2){
        $order->whereBetween('schduled_date', [$request->from_date, $request->to_date]);
            }

        if($request->has('from_date') && $request->has('to_date') && $request->date_type == 3){
        $order->whereBetween('shipping_date', [$request->from_date, $request->to_date]);
            }

            //  if($request->has('sortbystatus')){
            //  $order->orderBy('order_items.status','DESC');   
            // } 

            if($request->has('item') && $request->item > 0){
             $order->where('order_items.product_cat_id',$request->item);   
            }

            if($request->has('dealer') && $request->dealer > 0){
             $order->where('orders.user_id',$request->dealer);   
            }  

            if($request->has('order_status') && $request->order_status >= 0){
             $order->where('order_items.status',$request->order_status); 
            } 
            

            // if(!$request->has('sortbystatusdesc') || !$request->has('sortbystatus')){
            //     $order->orderBy('order_items.id', "desc");
            // }

            $orders = $order->get();

           $from_date = $request->from_date;
           $to_date = $request->to_date;
           $dealer = $request->dealer;
           $item = $request->item;
           $date_type = $request->date_type;
           $order_status = $request->order_status;


        $dealers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',3)->OrderBy('users.id','DESC')->get();

        $prod_cat = ProductCategory::orderBy('name','ASC')->get();


        return view('pages.orders.index',compact('orders','dealers','prod_cat','from_date','to_date','dealer','item','date_type','order_status'));
    }


        public function orderReport(Request $request)
    {   

        $order = Order::where('orders.status',1)->join('users','users.id','=','orders.user_id')
        ->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->select('orders.po_number','order_items.status','order_items.order_date','products.name','item.name as fabric_name','orders.shipping_pincode','order_items.*','users.first_name','users.last_name','products.image','order_items.pillow_qty','order_items.tufting','order_items.nailhead_id')->orderBy('order_items.id', "DESC");

        if($request->has('from_date') && $request->date_type == 1){
        $order->whereBetween('order_date', [$request->from_date, $request->to_date]);
            }

        if($request->has('from_date') && $request->date_type == 2){
        $order->whereBetween('schduled_date', [$request->from_date, $request->to_date]);
            }

        if($request->has('from_date') && $request->date_type == 3){
        $order->whereBetween('shipping_date', [$request->from_date, $request->to_date]);
            }

            if($request->has('item') && $request->item > 0){
             $order->where('order_items.product_cat_id',$request->item);   
            }

            if($request->has('dealer') && $request->dealer > 0){
             $order->where('orders.user_id',$request->dealer);
            }

            // if($request->has('dealer') && $request->dealer == -2 ){
            //   $order->join('model_has_roles','orders.user_id','=','model_has_roles.model_id')->where('model_has_roles.role_id',3); 
            // }

            if($request->has('dealer') && $request->dealer == 0 ){
              $order->join('model_has_roles','orders.user_id','=','model_has_roles.model_id')->where('model_has_roles.role_id',3); 
            }  

            if($request->has('dealer') && $request->dealer == -1){
              $order->join('model_has_roles','orders.user_id','=','model_has_roles.model_id')->where('model_has_roles.role_id',5); 
            }  

            if($request->has('dealer')){
              $orders = $order->get(); 
             
            } else {
               $orders = []; 
            }


            

           $from_date = $request->from_date;
           $to_date = $request->to_date;
           $dealer = $request->dealer;
           $item = $request->item;
           if($item > 0){
            $prod_cat_name = ProductCategory::where('id',$item)->first('name');
            $cat_name = $prod_cat_name->name;
           } else {
            $cat_name = "All Items";
           }
           $date_type = $request->date_type;
           $user = $request->dealer;


            if($date_type == 1){
                $mydate = "Order Date";
            } else if($date_type == 2){
                $mydate = "Scheduled Date";
            } else {
                $mydate = " Shipping Date";
            }

            if($request->dealer > 0){
                $deal = User::where('id',$user)->first();
                $deal_name =$deal->first_name;
            } else if($request->dealer == 0){
                $deal_name = " All Dealers";
            } else if($request->dealer == -1){
                $deal_name = "All On-Floor Elite";   
            } else {
                 $deal_name = " All Users";
            }


        $dealers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',3)->OrderBy('users.first_name','ASC')->get();

          $customers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',5)->OrderBy('users.first_name','ASC')->get();



        $prod_cat = ProductCategory::orderBy('name','ASC')->get();


        return view('pages.report.index',compact('orders','dealers','prod_cat','from_date','to_date','dealer','item','date_type','customers','user','cat_name','mydate','deal_name'));
    }

        public function show(Request $request)
    {   

        
        $orders = Order::where('orders.status',1)->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->select('order_items.id as order_det_id','orders.id as order_id','orders.user_id as user_id','order_items.total_price as total_price','orders.po_number as po_number','order_items.status as status','order_items.order_date','products.name','item.name as fabric_name','orders.billing_address','orders.billing_city','orders.billing_provience','orders.billing_country','orders.billing_pincode','orders.shipping_address','orders.shipping_city','orders.shipping_provience','orders.shipping_country','orders.shipping_pincode')->whereBetween('order_date', [$request->from_date, $request->to_date])->orderBy('order_items.id', "desc")->get();

         $dealers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',3)->OrderBy('users.id','DESC')->get();

        return view('pages.orders.index',compact('orders','dealers'));
    }

    /**
        * Show the form for creating a new resource.
        *
        * @return Response
    */

    public function create()
    {
        Session::forget('cart');
         Session::forget('po_number');
         Session::forget('order_id');
        $dealers=  User::select('*','users.id as id','cities.name as city_name','cities.id as city_id')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',3)->OrderBy('users.first_name','ASC')->get();

        //return $dealers;

        $products = ProductCategory::orderBy('name','ASC')->get();
        $fabrics = [];
        //$fabrics = Item::where('item_cat_id',1)->join('fabric_grade','fabric_grade.id','=','item.fabric_grade_id')->select('item.*','fabric_grade.name as grade','fabric_grade.price')->orderBy('item.name','ASC')->Where('is_available','0')->get();
       // $foams = Item::where('item_cat_id',2)->join('products','products.id','=','item.style')->select('products.name','item.id')->get();
         $mechanism = Item::where('item_cat_id',5)->where('is_available','yes')->orderBy('name','ASC')->get();
        $foams = Foam_Grade::orderBy('name','ASC')->get();
        $legs = Item::where('item_cat_id',3)->where('is_available','yes')->orderBy('name','ASC')->get();
        $nail_heads = Item::where('item_cat_id',4)->where('is_available','yes')->orderBy('name','ASC')->get();
        $pillows = Product::where('product_cat_id',9)->orderBy('name','ASC')->get();
        return view('pages.orders.create',compact('dealers','products','fabrics','foams','legs','nail_heads','pillows','mechanism'));
    }

    public function order_item(Request $request)
    { 
        $products = Product::where('product_cat_id',$request->order_item)->orderBy('name','ASC')->get();

        return $products;

    }

    public function downloadFile($id)
    { 

        //return $id;
        //$id = base64_decode($id);
        $item = Order_Item::where('id',$id)->first();

        if($item){
            $file = $this->url->to('/order').'/'.$item->image;

            //return $file;
            //return response()->download($file);
            return response()->file($file);

        }

        return redirect()->back();

    }

    public function get_foam_grade(Request $request)
    { 
        $item = Item::where('fabric_grade_id',$request->foam_grade)->where('style',$request->pro_id)->first();

        return $item;

    }

    public function get_customer(Request $request)
    { 
        if($request->customer_type == 2){
            $customer=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',5)->OrderBy('users.first_name','ASC')->get();
        } else{
            $customer=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',3)->OrderBy('users.first_name','ASC')->get();
        }
        

        return $customer;

    }

    public function get_customerEmail(Request $request)
    { 
        $user = User::where('email',$request->email)->first();

        return $user;

    }

    public function check_po(Request $request)
    { 
        $item = Order::where('po_number',$request->ponum)->where('user_id',$request->cust_id)->first();

        return $item;

    }


    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */

    public function create_order(Request $request)
    {
        //return $request;
        $order = Order::where('id',$request->order_id)->update(['status'=>1]);
        $order = Order::where('id',$request->order_id)->first();
        $order_det = Order_Item::where('order_id',$request->order_id)->first();

        if(!isset($order_det) || !isset($order_det->order_id)){
          return redirect('orders')->with('message', "Your cart is empty. Please add some products.");
        }

        //return $order;
        if(isset($order) && isset($order->user_id)){
        
        $user = User::where('id',$order->user_id)->first();
        
        if($order->user_type == 1){ // Rizwan: Send Email only if user is a dealer(user type = 1)
            try {
             $this->sendmail($request->order_id);
    
            } catch(Exception $e) {
                 return redirect('orders')->with('message', "Order has been created successfully. Mail Sending Failed ".$e);
            }
        }

        // $cart = \ShoppingCart::destroy();

         Session::forget('cart');
         Session::forget('po_number');
         Session::forget('order_id');
         Session::forget('total_price');

        return redirect('orders')->with('message', "Order has been created successfully");
        } else{
                Session::forget('cart');
                Session::forget('po_number');
                Session::forget('order_id');
                Session::forget('total_price');

        return redirect('orders')->with('message', "Order has been deleted by cron since it wasn't confirmed.");

        }

    } 

        public function orderStatus(Request $request)
    {
            if($request->status == 5){
                $this->cancelorder($request->item_id);
            }
        // return $request;
         $order_item = Order_Item::where('id',$request->item_id)->first();
         $order = Order::where('id',$order_item->order_id)->first();
         $user = User::where('id',$order->user_id)->first();

         $product = Product::where('id',$order_item->product_id)->first();


        $order_item->status = $request->status;
        if($order_item->save()){

            if($order_item->status == 0){
                $status = "Back Order";
            } elseif ($order_item->status == 1) {
                $status = "Order Received";
            } elseif ($order_item->status == 2) {
                $status = "Manufacturing";
            } elseif ($order_item->status == 3) {
                $status = "Ready To Ship";
            } elseif ($order_item->status == 4) {
                $status = "Shipped";
            } elseif ($order_item->status == 5) {
                $status = "Cancelled";
            }


        $data = array( 'name' => $user->first_name,'email'=> $user->email,'phone_no' => $user->phone_no,'user'=>$user,'order'=>$order,'order_det'=>$order_item,'po_number'=>$order->po_number,'status'=>$status,'product'=>$product);

        $mail=  Mail::send('email.order_status', $data, function($message) use($data) {
           $message->to($data['email'], $data['name'])

             // $message->to('abhishek.allalgos@gmail.com', $data['name'])
                  //  ->subject('Your Elite sofas order #'.$data['po_number'].' is '.$data['status']);
                    ->subject('The status of your following Elite Sofas order is changed to : '.$data['status']);
            $message->from('team@elitesofa.com','Elite Sofa Team');
        });

            return 1;
        }else{
            return 0;
        }
    }
    
    public function testmail()
    {    
        $data = [];

        try{
           $mailuser=  Mail::send('email.test', $data, function($message) use($data) {
                    $message->to('abhishek.allalgos@gmail.com', 'Abhi')

                     // $message->to('abhishek.allalgos@gmail.com', $data['name'])
                          ->subject('Your Elite sofas zzzzzzzzorder for PO # has been received');
                    $message->from(env('MAIL_USERNAME'),'Elite Sofa Team');
                });
        } catch(Exception $e){
            return $e;
        }


        
        return $mailuser;
    }

    public function sendmail($order_id)
    {
        //return $request;
        $order = Order::where('id',$order_id)->first();
        $user = User::where('id',$order->user_id)->first();
        $order_det = Order_Item::where('order_id',$order_id)->join('products','products.id','=','order_items.product_id')->join('product_category','product_category.id','=','order_items.product_cat_id')->select('order_items.*','products.name as name','product_category.name as cat_name')->get();

        $bcity = City::where('id',$user->shipping_city)->first('name');
        $bstate = State::where('id',$user->shipping_provience)->first('name');
        $bcountry = Country::where('id',$user->shipping_country)->first('name');

        $scity = City::where('id',$user->shipping_city)->first('name');
        $sstate = State::where('id',$user->shipping_provience)->first('name');
        $scountry = Country::where('id',$user->shipping_country)->first('name');


            foreach($order_det as $ord){
                 if($ord->status == 0){
                $status = "Back Order";
            } elseif ($ord->status == 1) {
                $status = "Order Received";
            } elseif ($ord->status == 2) {
                $status = "Manufacturing";
            } elseif ($ord->status == 3) {
                $status = "Ready To shipped";
            } elseif ($ord->status == 3) {
                $status = "Shipped";
            } elseif ($ord->status == 5) {
                $status = "Cancelled";
            }

            
                $ord->status = $status;
            }

         $data = array( 'name' => $user->first_name,'email'=> $user->email,'phone_no' => $user->phone_no,'user'=>$user,'order'=>$order,'order_det'=>$order_det,'bcity'=>$bcity,'bstate'=>$bstate,'bcountry'=>$bcountry,'scity'=>$scity,'sstate'=>$sstate,'scountry'=>$scountry,'po_number'=>$order->po_number,'superadmin'=>0);
        // $data = array( 'name' => $user->first_name,'email'=> $user->email);
           
         //return $data['scity'];

         try{
           $mailuser=  Mail::send('email.order', $data, function($message) use($data) {
                    $message->to($data['email'], $data['name'])

                     // $message->to('abhishek.allalgos@gmail.com', $data['name'])
                          ->subject('Your Elite sofas order for PO #'.$data['po_number'].' has been received');
                    $message->from(env('MAIL_USERNAME'),'Elite Sofa Team');
                });
        } catch(Exception $e) {
           return redirect('orders')->with('message', "Order has been created successfully. Mail Sending Failed ".$e);
        }

           // send Mail to Superadmin 
        try{
            $data['superadmin'] = 1;
            $mail=  Mail::send('email.order', $data, function($message) use($data) {
                    $message->to(env('MAIL_ADMIN_TO'), $data['name'])

                     // $message->to('abhishek.allalgos@gmail.com', $data['name'])
                          ->subject('Your Elite sofas order #'.$data['po_number'].' has been received');
                    $message->from(env('MAIL_USERNAME'),'Elite Sofa Team');
                });
        } catch(Exception $e) {
           return redirect('orders')->with('message', "Order has been created successfully. Mail Sending Failed ".$e);
        }

            

               // return view('email.order',compact('data'));

    } 





        public function delorder($id)
    {
        //return $id;
       
        $order_item = Order_Item::where('id',$id)->first();
        if($order_item){

            $check_count = Order_Item::where('order_id',$order_item->order_id)->get();

     
            if(count($check_count) <= 1){
                $ord = Order::where('id',$order_item->order_id)->first();
                $ord->delete();
            }



                    // add Product fabric  Req
        $item = Item::where('id',$order_item->fabric_id)->first();
        if($item){
        
        $type = "Order Deleted Fabric";
        $this->addFab($item->id,$order_item->id,$type,$order_item->fabric_required);

        }


      // Add Pillow fabric  Req

        if($order_item->product_cat_id != 9){
        $item = Item::where('id',$order_item->pillow_fabric)->first();
            if($item){
            
             $type = "Order Deleted Pillow";
             $this->addFab($item->id,$order_item->id,$type,$order_item->pillow_yard_req);

            }

        }


        // Add Mechanism Req
        if($order_item->mechanism_id){
        $item = Item::where('id',$order_item->mechanism_id)->first();
            if($item){
             $type = "Deleted Order Mechanism";
             $this->addFab($item->id,$order_item->id,$type,1);
            }
        }



      // Add Legs  Req
        if($order_item->leg_id){
        $item = Item::where('id',$order_item->leg_id)->first();
            if($item){
             $type = "Deleted Order Legs";
             $this->addFab($item->id,$order_item->id,$type,$order_item->legs_req);
            }
        }


      // Add Nailhead Req
        if($order_item->nailhead_id){
        $item = Item::where('id',$order_item->nailhead_id)->first();
            if($item){
             $type = "Deleted Order Nailhead";
             $this->addFab($item->id,$order_item->id,$type,$order_item->number_of_nailhead);

            }

        }


      // Add foam  Req 
        if($order_item->foam_type_id){
        $item = Item::where('fabric_grade_id',$order_item->foam_type_id)->where('style',$order_item->product_id)->first();
            if($item){
             $type = "Deleted Order Foam";
             $this->addFab($item->id,$order_item->id,$type,$order_item->foam_qty);
            }
        }


        $order_item->delete();
        }

        return redirect()->back()->with('message', 'Order deletd successfully.');

    }


        public function cancelorder($id)
    {
       
        $order_item = Order_Item::where('id',$id)->first();
        if($order_item){

            $check_count = Order_Item::where('order_id',$order_item->order_id)->get();


                    // add Product fabric  Req
        $item = Item::where('id',$order_item->fabric_id)->first();
        if($item){
        
        $type = "Cancel Order Fabric";
        $this->addFab($item->id,$order_item->id,$type,$order_item->fabric_required);

        }


      // Add Pillow fabric  Req

        if($order_item->product_cat_id != 9){
        $item = Item::where('id',$order_item->pillow_fabric)->first();
            if($item){
            
             $type = "Cancel Order Pillow";
             $this->addFab($item->id,$order_item->id,$type,$order_item->pillow_yard_req);

            }

        }


        // Add Mechanism Req
        if($order_item->mechanism_id){
        $item = Item::where('id',$order_item->mechanism_id)->first();
            if($item){
             $type = "Cancel Order Mechanism";
             $this->addFab($item->id,$order_item->id,$type,1);
            }
        }



      // Add Legs  Req
        if($order_item->leg_id){
        $item = Item::where('id',$order_item->leg_id)->first();
            if($item){
             $type = "Cancel Order Legs";
             $this->addFab($item->id,$order_item->id,$type,$order_item->legs_req);
            }
        }


      // Add Nailhead Req
        if($order_item->nailhead_id){
        $item = Item::where('id',$order_item->nailhead_id)->first();
            if($item){
             $type = "Cancel Order Nailhead";
             $this->addFab($item->id,$order_item->id,$type,$order_item->number_of_nailhead);

            }

        }


      // Add foam  Req 
        if($order_item->foam_type_id){
        $item = Item::where('fabric_grade_id',$order_item->foam_type_id)->where('style',$order_item->product_id)->first();
            if($item){
             $type = "Cancel Order Foam";
             $this->addFab($item->id,$order_item->id,$type,$order_item->foam_qty);
            }
        }


        }

        return redirect()->back()->with('message', 'Order Cancelled successfully.');

    }

    public function createpoorder()
    {

        //return "ss";
                $products = ProductCategory::orderBy('name','ASC')->get();
       

         $fabrics = Item::where('item_cat_id',1)->join('fabric_grade','fabric_grade.id','=','item.fabric_grade_id')->select('item.*','fabric_grade.name as grade','fabric_grade.price')->get();
        //$foams = Item::where('item_cat_id',2)->join('products','products.id','=','item.style')->select('products.name','item.id')->get();
         $foams = Foam_Grade::all();
        $legs = Item::where('item_cat_id',3)->get();
        $nail_heads = Item::where('item_cat_id',4)->get();
         $mechanism = Item::where('item_cat_id',5)->get();
        $pillows = Product::where('product_cat_id',9)->get();
        return view('pages.orders.createpo',compact('products','fabrics','foams','legs','nail_heads','pillows','mechanism'));
    }
    public function delorder_det(Request $request)
    {

        $order = Order_Item::where('id',$request->id)->first();
        if($order){

        // add Product fabric  Req
        $item = Item::where('id',$order->fabric_id)->first();
        if($item){
        
        $type = "Order Deleted";
        $this->addFab($item->id,$order->id,$type,$order->fabric_required);

        }


      // Add Pillow fabric  Req

        if($order->product_cat_id != 9){
        $item = Item::where('id',$order->pillow_fabric)->first();
            if($item){
    
             $type = "Order Pillow Delated";
             $this->addFab($item->id,$order->id,$type,$order->pillow_yard_req);

            }

        }


        // Add Mechanism Req
        if($order->mechanism_id){
        $item = Item::where('id',$order->mechanism_id)->first();
            if($item){
            
             $type = "Deleted Order Mechanism";
             $this->addFab($item->id,$order->id,$type,1);

            }

        }



      // Add Legs  Req

        if($order->leg_id){
        $item = Item::where('id',$order->leg_id)->first();
            if($item){
            
             $type = "Deleted Order Legs";
             $this->addFab($item->id,$order->id,$type,$order->legs_req);

            }

        }


      // Add Nailhead Req



        if($order->nailhead_id){
        $item = Item::where('id',$order->nailhead_id)->first();
            if($item){
            
             $type = "Deleted Order Nailhead";
             $this->addFab($item->id,$order->id,$type,$order->number_of_nailhead);

            }

        }


      // Add foam  Req 

        if($order->foam_type_id){
        $item = Item::where('fabric_grade_id',$order->foam_type_id)->where('style',$order->id)->first();
            if($item){
            
             $type = "Deleted Order Foam";
             $this->addFab($item->id,$order->id,$type,$order->foam_qty);

            }

        }



        $order->delete();
        }

         $products = Session::get('cart'); // Get the array
          Session::forget('cart');
         

        unset($products[$request->key]); // Unset the index you want

        $products = array_values($products);

        //print_r($products);
        Session::push('cart', $products);

        return $products;

    }

    public function Create_Usr($email,$name,$phone,$address)
    {
        $user = new User();
        $user->email = $email;
        $user->first_name = $name;

        if($phone){
        $num = preg_replace('/[^0-9.]/', '', $phone);
        $user->mobile     = $num;    
        }
        $user->mobile = $phone;
        $user->billing_address = $address;
        $user->shipping_address = $address;
        $user->save();

        $user->assignRole( array('0' => 5 ));

        return $user;
    }

        public function addto_cart(Request $request)
    {   ini_set('memory_limit', '-1');
    //return $request;

        $validator = Validator::make($request->all(), [
            // 'customer_name'  => 'required',

            'product_qty'  => 'required',
            'scheduled_date'  => 'required',
            'estimate_shipping_date'  => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }
        

        if($request->private_customer_email){

            $check_user = User::where('email',$request->private_customer_email)->first();

            if($check_user)
            {
                return redirect()->back()->withErrors($validator)->withInput()->with('message', "User Already Exists. Please Use different Email.");
            }
            $customer = $this->Create_Usr($request->private_customer_email,$request->private_customer_name,$request->private_customer_phone_no,$request->private_customer_address);
        } else {
            $customer = User::where('id',$request->sel_customer_id)->first();
        }

        if(!$customer){
          $customer = User::where('id',$request->customer_name)->first();
          }


      $order = Order::where('id',$request->order_id)->first();

      if(!$order){

        if($request->po_number != ''){
            $check_po = Order::where('po_number',$request->po_number)->where('user_id',$request->customer_name)->first();
        

         // if($check_po){
         //    return redirect()->back()->withErrors($validator)->withInput()->with('message', "PO Number can't be same");
         // }
        }
      $order = new Order();
      $order->user_id = $customer->id;
      $order->po_number = $request->po_number;
      $order->user_type = !empty($request->customer) ? $request->customer: 1;
      $order->billing_address = $customer->billing_address;
      $order->billing_city = $customer->billing_city;
      $order->billing_provience = $customer->billing_provience;
      $order->billing_country = $customer->billing_country;
      $order->billing_pincode = $customer->billing_pincode;
      $order->is_shipping_address_different = $customer->is_shipping_address_different;
      $order->shipping_address = $customer->shipping_address;
      $order->shipping_city = $customer->shipping_city;
      $order->shipping_provience = $customer->shipping_provience;
      $order->shipping_country = $customer->shipping_country;
      $order->shipping_pincode = $customer->shipping_pincode;
      if($request->cost > 0){
         $order->price = $request->cost;
     } else {
        $order->price = 0;
     }
     
      $order->status = 0;
      $order->tax = $request->tax;
      if($request->total_bill > 0){
      $order->total_price = $request->total_bill;
        } else {
         $order->total_price = 0;   
        }
      $order->save();
    } else{
      $order->tax = $request->tax;
      $order->total_price = $order->total_price + $request->total_bill;
      $order->update();
    }
     

           //upload image
        if($request->hasfile('attachment'))
        {
            $image = $request->file('attachment');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/order/');
            $image->move($destinationPath, $name);
            $image = $name;
        } else {
            $image = "";
        }

      $num = intval($request->product_qty);
      //return $num;
      for ($i=0; $i < $num; $i++) { 

      $order_item = new Order_Item();
      $order_item->order_id = $order->id;
      $order_item->product_id = $request->style;
      $order_item->product_cat_id = $request->order_item;
      $order_item->fabric_id = $request->fabric;
      $order_item->fabric_required = $request->yardget;

      // check back order

      $fabric = Item::where('id',$request->fabric)->where('item_cat_id',1)->first();
      $pil_fabric = Item::where('id',$request->pillow_fabric)->where('item_cat_id',1)->first();

       //return $fabric;

      if(isset($fabric) && $fabric->quantity_available >= $request->yardget)
      {
            $order_item->status = 1;
            if($request->is_pillow_req != 'on' && $request->pillow_ord_qty > 0){
        if(isset($pil_fabric) && $pil_fabric->quantity_available >= $request->pillow_ord_qty && $request->pillow_ord_qty > 0)
          {
             $order_item->status = 1;
          } else{
             $order_item->status = 0;
          } }
      }else {
             $order_item->status = 0;
      }

      




      // if($request->has('back_order') && $request->back_order == 5){
      //   $order_item->status = 0;
      // } else {
      //   $order_item->status = 1;
      // }

      
      
      $order_item->pillow_qty = $request->pillow_qty;
      if($request->order_item == 9){

        $order_item->fabric_required = $request->yardget * $request->pillow_ord_qty;
         $order_item->pillow_qty = $request->pillow_ord_qty;

               if(isset($fabric) && $fabric->quantity_available >= $order_item->fabric_required)
                      {
                            $order_item->status = 1;
                      
                      }else {
                             $order_item->status = 0;
                      }

      }
      
      $order_item->fabric_grade_id = $request->gradeD;
      $order_item->leg_id = $request->legs_type;
      if($request->legs_req > 0){
      $order_item->legs_req = $request->legs_req;  
      } else {
        $order_item->legs_req = 0;
      }
      
      $order_item->nailhead_id = $request->nailhead;
      if($request->number_of_nailhead){
      $order_item->number_of_nailhead = $request->number_of_nailhead;
      } else {
      $order_item->number_of_nailhead = 0;

      }
      $order_item->foam_style_id = $request->foam_type;

      if(!$request->is_pillow_req){
      $order_item->pillow_fabric = $request->pillow_fabric;
      $order_item->pillow_style = $request->pillow_style;
      $order_item->pillow_yard_req = $request->pillow_yard_req;
      
        } else {
      $order_item->is_pil_not_req    = 1;
        }
         if($request->mechanism && $request->mechanism > 0){
      $order_item->mechanism_id = $request->mechanism;
            }
      $order_item->foam_type_id = $request->foam_type;
      $order_item->foam_qty = $request->foam_qty;
      $order_item->tufting = $request->tufting;
      $order_item->size = $request->gradeSize;
      $order_item->order_date = $request->order_date;
      $order_item->schduled_date = $request->scheduled_date;
      $order_item->shipping_date = $request->estimate_shipping_date;
      if($request->cost > 0){
         $order_item->price = $request->cost;
     } else {
        $order_item->price = 0;
     }
      $order_item->tax = $request->tax;
       if($request->total_bill > 0){
        $order_item->total_price = $request->total_bill;
     } else {
        $order_item->total_price = 0;
     }
            $order_item->order_description = $request->order_description;


      $order_item->image = $name;
      $order_item->save();



      // deduct Product fabric  Req
        $item = Item::where('id',$request->fabric)->first();
        if($item){
        $type = "Order Fabric";
        if($request->order_item == 9){
            $pillow_yard = $request->yardget * $request->pillow_ord_qty;
            } else {
            $pillow_yard =  $request->yardget;
            }

        $item->save();

            $ded= $this->deductFab($item->id,$order_item->id,$type,$pillow_yard);
        }


      // deduct Pillow fabric  Req

        if($request->order_item != 9){
        $item = Item::where('id',$request->pillow_fabric)->first();
            if($item){
            $type = "Order Pillow";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$request->pillow_yard_req);

            }
        }


      // Mechanism Deduction  Req

        if($request->mechanism && $request->mechanism > 0){
        $item = Item::where('id',$request->mechanism)->first();
            if($item){
            $type = "Order Mechanism";
            $ded= $this->deductFab($item->id,$order_item->id,$type,1);

            }
        }

      // Legs Deduction  Req

        if($request->legs_type){
        $item = Item::where('id',$request->legs_type)->first();
            if($item){
            $type = "Order Legs Ded";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$request->legs_req);

            }
        }

      // Nailhead Deduction  Req

        if($request->nailhead){
        $item = Item::where('id',$request->nailhead)->first();
            if($item){
            $type = "Order Nailhead";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$request->number_of_nailhead);

            }
        }

      // foam deduction  Req 
        if($request->foam_type){
        $item = Item::where('fabric_grade_id',$request->foam_type)->where('style',$request->style)->first();
            if($item){
            $type = "Order Foam  Deduction";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$order_item->foam_qty);
            }
        }

        //for end
    }


       $sel_product = Product::where('id', $request->style)->first();
        $sel_fabric = Item::where('item_cat_id',1)->where('item.id',$request->fabric)->join('fabric_grade','fabric_grade.id','=','item.fabric_grade_id')->select('item.*','fabric_grade.name as grade')->first();



      $carts = ['order_id'=>$order->id ,'order_det_id'=>$order_item->id, 'item_name' => $sel_product->name , 'sel_fabric'=>$sel_fabric->name, 'price'=>$request->total_bill, 'po_number'=>$request->po_number,'total_bill'=>$order->total_price,'product_qty'=>$request->product_qty];

      $session = Session::push('cart', $carts);
       $cart = Session::get('cart');
       $po_num = Session::push('po_number',$request->po_number);
       $order_id = Session::push('order_id',$order->id);
       $total = Session::push('total_price',$order->total_price);

       if($order->user_type == 1){
         $dealers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',3)->OrderBy('users.id','DESC')->get();
     } else {
         $dealers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',5)->OrderBy('users.id','DESC')->get();
     }
            

        $products = ProductCategory::orderBy('name','ASC')->get();
       

         $fabrics = Item::where('item_cat_id',1)->join('fabric_grade','fabric_grade.id','=','item.fabric_grade_id')->select('item.*','fabric_grade.name as grade','fabric_grade.price')->OrderBy('name','ASC')->get();
        //$foams = Item::where('item_cat_id',2)->join('products','products.id','=','item.style')->select('products.name','item.id')->get();
         $foams = Foam_Grade::all();
        $legs = Item::where('item_cat_id',3)->OrderBy('name','ASC')->get();
        $nail_heads = Item::where('item_cat_id',4)->OrderBy('name','ASC')->get();
         $mechanism = Item::where('item_cat_id',5)->OrderBy('name','ASC')->get();
        $pillows = Product::where('product_cat_id',9)->OrderBy('name','ASC')->get();

        $customer = User::where('users.id',$customer->id)->leftjoin('cities','cities.id','=','users.billing_city')->select('users.*','cities.name as city_name')->first();

        if($order->user_type == 2){
         $customer = User::where('users.id',$customer->id)->select('*','shipping_address as city_name')->first();   
        }


        return view('pages.orders.create',compact('dealers','products','fabrics','foams','legs','nail_heads','pillows','order','sel_product','sel_fabric','customer','mechanism','session'))->with('message', 'Product added to cart successfully.');

    }


    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function sublist($id)
    {
        $orders = Order::join('order_items','order_items.order_id','=','orders.id')->where('orders.id',$id)->get();
       // $order_det = Order_Item::where('order_id',$id)->get();
        return view('pages.orders.sublist',compact('orders'));
    }

    public function update_scheduled(Request $request)
    {

          $validator = Validator::make($request->all(), [
            'scheduled_date'  => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }
          //return $request;
          $order_item = Order_Item::find($request->schduled_date_input);
          $order_item->schduled_date = $request->scheduled_date;
          if($request->shipping_date == 'on'){
             $order_item->shipping_date = $request->date_sch;
          }
             if($request->same_po == 'on'){
           $same_po = DB::table('order_items')->where('order_id', $order_item->order_id)->update(['schduled_date'=>$request->scheduled_date, 'shipping_date'=>$request->date_sch]); 
          }

          $order_item->save();
         
          return redirect('orders');

    }

        public function checkCron()
        {

            $date = new DateTime;

            $date->modify('-15 minutes');
            $formatted_date = $date->format('Y-m-d H:i:s');

            $message = Order::where('status',0)->whereDate('created_at','<=',$formatted_date)->get();

            foreach($message as $msg){
                $message = Order_Item::where('order_id',$msg->id)->delete();
                $message = Order::where('id',$msg->id)->delete();
            }

            return $message;
        }


    public function update_shipping(Request $request)
    {
          //return $request;

         $validator = Validator::make($request->all(), [
            'shipping_date'  => 'required',
        ]);
         
          $order_item = Order_Item::find($request->shipping_date_input);
          $order_item->shipping_date = $request->shipping_date;
          // if($request->shipping_date == 'on'){
          //    $order_item->shipping_date = $request->date_sch;
          // }
          //    if($request->same_po == 'on'){
          //  $same_po = DB::table('order_items')->where('order_id', $order_item->order_id)->update(['schduled_date'=>$request->scheduled_date, 'shipping_date'=>$request->date_sch]); 
          // }

          $order_item->save();
         
          return redirect('orders');

    }
    public function updateorder(Request $request)
    {
        //return $request;

      $order_item = Order_Item::find($request->order_det_id);

      if($order_item){


        // add Product fabric  Req
        $item = Item::where('id',$order_item->fabric_id)->first();
        if($item){
        
        $type = "Order Updated Fabric";
        $this->addFab($item->id,$order_item->id,$type,$order_item->fabric_required);

        }


      // Add Pillow fabric  Req

        if($order_item->product_cat_id != 9){
        $item = Item::where('id',$order_item->pillow_fabric)->first();
            if($item){
            
             $type = "Order Updated Pillow";
             $this->addFab($item->id,$order_item->id,$type,$order_item->pillow_yard_req);

            }

        }


        // Add Mechanism Req
        if($order_item->mechanism_id){
        $item = Item::where('id',$order_item->mechanism_id)->first();
            if($item){
             $type = "Updated Order Mechanism";
             $this->addFab($item->id,$order_item->id,$type,1);
            }
        }



      // Add Legs  Req
        if($order_item->leg_id){
        $item = Item::where('id',$order_item->leg_id)->first();
            if($item){
             $type = "Updated Order Legs";
             $this->addFab($item->id,$order_item->id,$type,$order_item->legs_req);
            }
        }


      // Add Nailhead Req
        if($order_item->nailhead_id){
        $item = Item::where('id',$order_item->nailhead_id)->first();
            if($item){
             $type = "Updated Order Nailhead";
             $this->addFab($item->id,$order_item->id,$type,$order_item->number_of_nailhead);

            }

        }


      // Add foam  Req 
        if($order_item->foam_type_id){
        $item = Item::where('fabric_grade_id',$order_item->foam_type_id)->where('style',$order_item->product_id)->first();
            if($item){
             $type = "Updated Order Foam";
             $this->addFab($item->id,$order_item->id,$type,$order_item->foam_qty);
            }
        }


        if($request->has('style')){
          $order_item->product_id = $request->style;
        }

        if($request->has('order_item')){
      $order_item->product_cat_id = $request->order_item;
           }

        if($request->has('fabric')){
      $order_item->fabric_id = $request->fabric;
           }

        if($request->has('gradeD')){
      $order_item->fabric_grade_id = $request->gradeD;
           }
                 
        if($request->has('legs_type')){
      $order_item->leg_id = $request->legs_type;
           }
                       
        if($request->has('nailhead')){
        $order_item->nailhead_id = $request->nailhead;
           }
                             
        if($request->has('foam_type')){
        $order_item->foam_style_id = $request->foam_type;
           } 

        if($request->has('legs_req')){
        $order_item->legs_req = $request->legs_req;
           } 
                                        
        if($request->has('number_of_nailhead')){
        $order_item->number_of_nailhead = $request->number_of_nailhead;
           } 

        if($request->has('pillow_fabric')){
         $order_item->pillow_fabric = $request->pillow_fabric;
           } 
        if($request->has('pillow_style')){
         $order_item->pillow_style = $request->pillow_style;
           }                             
        if($request->has('mechanism')){
        $order_item->mechanism_id = $request->mechanism;
           }                             
        if($request->has('foam_type')){
        $order_item->foam_type_id = $request->foam_type;           
            }                             
        if($request->has('foam_qty')){
        $order_item->foam_qty = $request->foam_qty;
           }                             
        if($request->has('pillow_yard_req')){
        $order_item->pillow_yard_req = $request->pillow_yard_req;
           }


        if($request->has('tufting')){
        $order_item->tufting = $request->tufting;
           }
           
        if($request->has('gradeSize')){
        $order_item->size = $request->gradeSize;
           }
                      
        if($request->has('pillow_qty')){
        $order_item->pillow_qty = $request->pillow_qty;
           }
           
        if($request->has('order_date')){
        $order_item->order_date = $request->order_date;
           }
           
        if($request->has('scheduled_date')){
        $order_item->schduled_date = $request->scheduled_date;
           }
           
        if($request->has('estimate_shipping_date')){
         $order_item->shipping_date = $request->estimate_shipping_date;
           }
           
        if($request->has('cost')){
        $order_item->price = $request->cost;
           }

        if($request->has('tax')){
        $order_item->tax = $request->tax;
           }
                      
        if($request->has('total_price')){
        $order_item->total_price = $request->total_bill;  
                 }
                      
        if($request->has('order_description')){
         $order_item->order_description = $request->order_description;  
                 }

        if($request->has('status')){
         $order_item->status = $request->status;  
                 }


                   //upload image
        if($request->hasfile('attachment'))
        {
            $image = $request->file('attachment');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/order/');
            $image->move($destinationPath, $name);
            $order_item->image = $name;
        }
     
   
      $order_item->save();


            // deduct Product fabric  Req
        $item = Item::where('id',$request->fabric)->first();
        if($item){
 
        if($request->order_item == 9){
            $pillow_yard = $request->yardget * $request->pillow_qty;
            } else {
            $pillow_yard = $request->yardget;
            }

        $type = "Edit Order Pillow ded";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$pillow_yard);
        }


      // deduct Pillow fabric  Req

        if($request->order_item != 9){
        $item = Item::where('id',$request->pillow_fabric)->first();
            if($item){
            $type = "Order Pillow ded";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$request->pillow_yard_req);

            }

        }



      // Mechanism Deduction  Req

        if($request->mechanism){
        $item = Item::where('id',$request->mechanism)->first();
            if($item){
            $type = "Order Mechanism";
            $ded= $this->deductFab($item->id,$order_item->id,$type,1);

            }
        }

      // Legs Deduction  Req

        if($request->legs_type){
        $item = Item::where('id',$request->legs_type)->first();
            if($item){
            $type = "Order Legs Ded";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$request->legs_req);

            }
        }

      // Nailhead Deduction  Req

        if($request->nailhead){
        $item = Item::where('id',$request->nailhead)->first();
            if($item){
            $type = "Order Nailhead";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$request->number_of_nailhead);

            }
        }

      // foam deduction  Req 
         if($order_item->foam_type_id){
        $item = Item::where('fabric_grade_id',$order_item->foam_type_id)->where('style',$order_item->product_id)->first();
            if($item){
            $type = "Order Foam  Deduction";
            $ded= $this->deductFab($item->id,$order_item->id,$type,$order_item->foam_qty);
            }
        }

     }
        return redirect('orders')->with('message', "Order has been Updated successfully");
    }

    public function editOrder($id)
    {
        
        $order_det = Order_Item::where('id',$id)->first();

        //return $order_det;
        $orders = Order::find($order_det->order_id);
        $customer = User::find($orders->user_id);
        //return $customer;

     if($orders->user_type == 1){
         $dealers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',3)->OrderBy('users.id','DESC')->get();
     } else {
         $dealers=  User::select('*','users.id as id','cities.name as city_name')->join('model_has_roles','users.id','=','model_has_roles.model_id')->leftjoin('cities','cities.id','=','users.billing_city')->where('model_has_roles.role_id',5)->OrderBy('users.id','DESC')->get();
     }

        $products = ProductCategory::orderBy('name','ASC')->get();
        $fabrics = Item::where('item_cat_id',1)->join('fabric_grade','fabric_grade.id','=','item.fabric_grade_id')->Where('is_available','0')->select('item.*','fabric_grade.name as grade','fabric_grade.price')->get();
       // $foams = Item::where('item_cat_id',2)->join('products','products.id','=','item.style')->select('products.name','item.id')->get();
         $mechanism = Item::where('item_cat_id',5)->where('is_available','yes')->get();
        $foams = Foam_Grade::all();
        $legs = Item::where('item_cat_id',3)->where('is_available','yes')->get();
        $nail_heads = Item::where('item_cat_id',4)->where('is_available','yes')->get();
        $pillows = Product::where('product_cat_id',9)->get();
        $sel_prod_list = Product::where('product_cat_id',$order_det->product_cat_id)->get();
        $sel_prod = Product::where('id',$order_det->product_id)->first();
        $sel_fab = Item::where('id',$order_det->fabric_id)->first();
        $sel_pil_fab = Item::where('id',$order_det->pillow_fabric)->first();
        return view('pages.orders.edit',compact('dealers','products','fabrics','foams','legs','nail_heads','pillows','mechanism','orders','order_det','customer','sel_prod_list','sel_prod','sel_fab','sel_pil_fab'));
  
    }



    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */
   



     function deductFab($fab_id,$order_det_id,$type,$yard_ded){

        $item = Item::where('id',$fab_id)->first();
        if($item){
        
        // stock history
        $stock =new  Stock_History;
        $stock->item_id = $item->id;
        $stock->order_id = $order_det_id;
        $stock->type = $type;
        $stock->stock_removed = $yard_ded;
        $stock->user_id = Auth::user()->id;
        $stock->stock_avl = $item->quantity_available;
        $stock->total_avl = $item->quantity_available - $yard_ded;
        $stock->save();

        // stock item
        $item->quantity_available = $item->quantity_available - $yard_ded;
        $item->save();

         }
    }

     function addFab($fab_id,$order_det_id,$type,$yard_add){

        $item = Item::where('id',$fab_id)->first();
        if($item){
        
        // stock history
            $stock =new  Stock_History;
            $stock->item_id = $fab_id;
            $stock->order_id = $order_det_id;
            $stock->type = $type;
            $stock->stock_added = $yard_add;
            $stock->user_id = Auth::user()->id;
            $stock->stock_avl = $item->quantity_available;
            $stock->total_avl = $item->quantity_available + $yard_add;
            $stock->save();

            $item->quantity_available = $item->quantity_available + $yard_add;
            $item->save();

         }
    }


    function schedule_date_update(Request $request){       
        $unserializeData = [];
        parse_str($request->formdata,$unserializeData);
        $order_item = Order_Item::find($unserializeData['scheduled_item_order_id']);
        if($unserializeData['scheduled_date']){
        $order_item->schduled_date = $unserializeData['scheduled_date'];
           }
           
        if($unserializeData['estimate_shipping_date']){
            $order_item->shipping_date = $unserializeData['estimate_shipping_date'];
        } 
        $order_item->save();
        return 1;

    }

    public function get_fabric (){

        $fabrics = Item::where('item_cat_id',1)->join('fabric_grade','fabric_grade.id','=','item.fabric_grade_id')->select('item.*','fabric_grade.name as grade','fabric_grade.price')->orderBy('item.name','ASC')->Where('is_available','0')->get();
     


        return $fabrics;
    }

        public function index()
    {
        
        return view('pages.orders.orders');
    }


    public function exportCsv(Request $request)
   {
   $fileName = 'orders.csv';
   $tasks = Order::where('orders.status',1)->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->leftjoin('users','users.id','=','orders.user_id')->select('order_items.id as order_det_id','orders.id as order_id','orders.user_id as user_id','order_items.total_price as total_price','orders.po_number as po_number','order_items.status as status','order_items.order_date','products.name','item.name as fabric_name','orders.billing_address','orders.billing_city','orders.billing_provience','orders.billing_country','orders.billing_pincode','orders.shipping_address','orders.shipping_city','orders.shipping_provience','orders.shipping_country','orders.shipping_pincode','order_items.*','users.email','users.first_name','users.last_name');

            if($request->get('status') >= 0 && $request->get('status') != '')
            {
                //return $request->status;
               $tasks->where('order_items.status',$request->status);  
            }

                if($request->get('search')){
                
                $search = $request->get('search');
                
                $tasks = $tasks->where('users.first_name', 'like', '%'.$search.'%')->orWhere('users.last_name', 'like', '%'.$search.'%')->orWhere('products.name', 'like', '%'.$search.'%')->orWhere('order_items.order_date', 'like', '%'.$search.'%')->orWhere('orders.po_number', 'like', '%'.$search.'%')->orWhere('order_items.schduled_date', 'like', '%'.$search.'%')->orWhere('order_items.shipping_date', 'like', '%'.$search.'%');
                            
            }

         $tasks = $tasks->orderBy('order_items.id', "desc")->get();

         //return $tasks;

        $headers = array(
            "Content-type"        => "text/csv",
            "Content-Disposition" => "attachment; filename=$fileName",
            "Pragma"              => "no-cache",
            "Cache-Control"       => "must-revalidate, post-check=0, pre-check=0",
            "Expires"             => "0"
        );

        $columns = array('PO Number','Order Date', 'Dealer Name', 'Product Name', 'Fabric', 'Status', 'Email', 'Billing Address','Billing City','Billing Provience','Billing Country','Billing Pincode','Shipping Address','Shipping City','Shipping Provience','Shipping Country','Shipping Pincode','Fabric Required','Tufting','Legs','Nailhead','Foam Style','Foam Quantity','Mechanism','Foam Grade','Pillow Fabric','Pillow Style','Pillow Quantity','Pillow Fabric Yard Req','Price','Tax','Schduled Date','Total Price','Shipping Date','Order Description');

        $callback = function() use($tasks, $columns) {
            $file = fopen('php://output', 'w');
            fputcsv($file, $columns);
            foreach ($tasks as $order) {
                // $dealer_name = User::where('id',$order->user_id)->value('first_name')." ".User::where('id',$order->user_id)->value('last_name');
                if($order->status ==0){
                    $status = "Back Order";
                }
                elseif($order->status ==1){
                    $status = "Order Received";
                }
                elseif($order->status ==2){
                    $status = "Manufacturing";
                }
                elseif($order->status ==3){
                    $status = "Ready To Ship";
                }
                elseif($order->status ==4){
                    $status = "Shipped";
                }
                else{
                    $status = "Cancelled";
                }

                // $email              = User::where('id',$order->user_id)->value('email');
                $billing_city       = City::where('id',$order->billing_city)->value('name');
                $billing_provience  = State::where('id',$order->billing_provience)->value('name');
                $billing_country    = Country::where('id',$order->billing_country)->value('name');
                $shipping_city      = City::where('id',$order->shipping_city)->value('name');
                $shipping_provience = State::where('id',$order->shipping_provience)->value('name');
                $shipping_country   = Country::where('id',$order->shipping_country)->value('name');
                $foam_grade         = Foam_Grade::where('id',$order->foam_style_id)->value('name');
                $pillow_fabric      = Item::where('id',$order->pillow_fabric)->value('name');
                $pillow_style       = Product::where('id',$order->pillow_style)->value('name');
                    
                $row['po_number']     = $order->po_number;
                $row['order_date']    = $order->order_date;
                $row['dealer_name']   = $order->first_name.' '.$order->last_name;
                $row['name']          = $order->name;
                $row['fabric_name']   = $order->fabric_name;
                $row['status']        = $status;
                $row['email']         = $order->email;
                $row['billing_address']    = $order->billing_address;
                $row['billing_city']       = $billing_city;
                $row['billing_provience']  = $billing_provience;
                $row['billing_country']    = $billing_country;
                $row['billing_pincode']    = $order->billing_pincode;
                $row['shipping_address']    = $order->shipping_address;
                $row['shipping_city']       = $shipping_city;
                $row['shipping_provience']  = $shipping_provience;
                $row['shipping_country']    = $shipping_country;
                $row['shipping_pincode']    = $order->shipping_pincode;
                $row['fabric_required']    = $order->fabric_required;
                $row['tufting']            = $order->tufting;
                $row['leg_id']             = $this->get_itemname($order->leg_id);
                $row['nailhead_id']        = $this->get_itemname($order->nailhead_id);
                $row['foam_style_id']    = $this->get_itemname($order->foam_style_id);
                $row['foam_qty']    = $order->foam_qty;
                $row['mechanism_id']       = $this->get_itemname($order->mechanism_id);
                $row['foam_grade']  = $foam_grade;
                $row['pillow_fabric']    = $pillow_fabric;
                $row['pillow_style']    = $pillow_style;
                $row['pillow_qty']    = $order->pillow_qty;
                $row['pillow_yard_req']       = $order->pillow_yard_req;
                $row['price']  = $order->price;
                $row['tax']    = $order->tax;
                $row['schduled_date']       = $order->schduled_date;
                $row['total_price']  = $order->total_price;
                $row['shipping_date']    = $order->shipping_date;
                $row['order_description']    = $order->order_description;

                fputcsv($file, array($row['po_number'], $row['order_date'], $row['dealer_name'], $row['name'], $row['fabric_name'], $row['status'], $row['email'], $row['billing_address'], $row['billing_city'], $row['billing_provience'], $row['billing_country'], $row['billing_pincode'], $row['shipping_address'], $row['shipping_city'], $row['shipping_provience'], $row['shipping_country'], $row['shipping_pincode'], $row['fabric_required'], $row['tufting'], $row['leg_id'], $row['nailhead_id'], $row['foam_style_id'], $row['foam_qty'], $row['mechanism_id'], $row['foam_grade'], $row['pillow_fabric'], $row['pillow_style'], $row['pillow_qty'], $row['pillow_yard_req'], $row['price'], $row['tax'], $row['schduled_date'], $row['total_price'], $row['shipping_date'], $row['order_description']));
                }

            fclose($file);
        };

        return response()->stream($callback, 200, $headers);
    }

    public function getnewOrders(Request $request)
    {
        
        if ($request->ajax()) {
            $order_status = '';
            //$search = '';
            $orders = Order::where('orders.status',1)->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->leftjoin('users','users.id','=','orders.user_id')->select('order_items.id as order_det_id','orders.id as order_id','orders.user_id as user_id','order_items.total_price as total_price','orders.po_number as po_number','order_items.status as status','order_items.order_date','order_items.schduled_date','order_items.shipping_date','products.name','item.name as fabric_name','orders.billing_address','orders.billing_city','orders.billing_provience','orders.billing_country','orders.billing_pincode','orders.shipping_address','orders.shipping_city','orders.shipping_provience','orders.shipping_country','orders.shipping_pincode','order_items.*');
            if($request->get('status_order')){
                $order_status = $request->get('status_order');
                if($order_status == '-1'){
                    $order_status = 0;
                }
                $orders = $orders->where('order_items.status',$order_status);
            }

            if($request->get('search')){
                
                $search = $request->get('search');
                if($search == '-1'){
                    $search = 0;
                }
                
                $orders = $orders->where('users.first_name', 'like', '%'.$search.'%')->orWhere('users.last_name', 'like', '%'.$search.'%')->orWhere('products.name', 'like', '%'.$search.'%')->orWhere('order_items.order_date', 'like', '%'.$search.'%')->orWhere('orders.po_number', 'like', '%'.$search.'%')->orWhere('order_items.schduled_date', 'like', '%'.$search.'%')->orWhere('item.name','like','%'.$search.'%')->orWhere('order_items.shipping_date', 'like', '%'.$search.'%');
                            
            }

            $orders = $orders->orderBy('order_items.id', "desc")->get();
            return Datatables::of($orders)
                ->addIndexColumn()
                ->addColumn('action', function($row){
                    $action_html = '';
                    if($row->status < 3){
                        $action_html .= '<div class="menu-item px-3"><a href="'.url('edit')."/".$row->order_det_id.'" class="menu-link px-3"><i class="fas fa-edit"></i></a></div>';
                    }
                    $action_html .= '<div class="menu-item px-3">
                                        <a href="'.url('order-view')."/".base64_encode($row->order_id)."/".base64_encode($row->order_det_id).'" class="menu-link px-3"><i class="fa fa-eye"></i></a>
                                    </div>';  
                    if($row->status < 2){
                        $action_html .= '<div class="menu-item px-3"><a href="'.url('order-delete')."/".$row->order_det_id.'" class="menu-link px-3 delete-order" ><i class="fa fa-trash"></i>
                        </a></div>';
                    }
                    $action_html .= "</div>";   
                    return $action_html;
                })
                ->addColumn('schduled_date1', function($order){
                     
                     if($order->status < 3){
                     $order_schedule_html = $order->schduled_date.'<button class="schduled_date" data-id="'.$order->order_det_id.'"><i class="fa fa-pencil"></i> </button>';
                     return $order_schedule_html;
                 } else {
                    $order_schedule_html = $order->schduled_date;
                     return $order_schedule_html;
                 }

                })
                ->addColumn('shipping_date1', function($order){
                     
                     /*if($order->status < 3){*/
                     if($order->status < 4){
                     $order_schedule_html = $order->shipping_date.'<button class="shippingmodelbtn" data-id="'.$order->order_det_id.'" data-sch_date="'.$order->schduled_date.'"><i class="fa fa-pencil"></i></button>';
                     return $order_schedule_html;
                 } else {
                    $order_schedule_html = $order->shipping_date;
                     return $order_schedule_html;
                 }

                })
                ->addColumn('order_status', function($order){
                    $order_status_html = '';
                    $order_status_html .= '<select class="form-control order-status" item_id="'.$order->order_det_id.'">';

                    if($order->status ==0) {
                        $order_status_html .= '<option value="0" selected>Back Order</option>';
                    }else{

                        $order_status_html .= '<option value="0" disabled >Back Order</option>';
                    }

                    if($order->status ==1) {
                        $order_status_html .= '<option value="1" selected>Order Received</option>';
                    }else{
                        if($order->status > 1){
                        $order_status_html .= '<option value="1" disabled>Order Received</option>';
                        } else {
                         $order_status_html .= '<option value="1" >Order Received</option>';   
                        }
                    }

                    if($order->status ==2) {
                        $order_status_html .= '<option value="2" selected>Manufacturing</option>';
                    }else{
                        if($order->status > 2){
                        $order_status_html .= '<option value="2" disabled>Manufacturing </option>';
                        } else {
                        $order_status_html .= '<option value="2" >Manufacturing</option>';
                        }
                    }

                    if($order->status ==3) {
                        $order_status_html .= '<option value="3" selected>Ready To Ship</option>';
                    }else{
                        if($order->status > 3){
                        $order_status_html .= '<option value="3" disabled>Ready To Ship </option>';
                        } else {
                        $order_status_html .= '<option value="3">Ready To Ship</option>';
                        }
                    }

                    if($order->status ==4) {
                        $order_status_html .= '<option value="4"  selected>Shipped</option>';
                    }else{
                         if($order->status > 4){
                        $order_status_html .= '<option value="4" disabled>Shipped </option>';
                        } else {
                        $order_status_html .= '<option value="4" >Shipped</option>';
                        }
                    }

                    if($order->status ==5) {
                        $order_status_html .= '<option value="5"  selected>Cancelled</option>';
                    }else{
                         if($order->status > 2){
                        $order_status_html .= '<option value="5" disabled>Cancelled </option>';
                        } else {
                        $order_status_html .= '<option value="5" >Cancelled</option>';
                        }
                    }

                    $order_status_html .= '</select>';  
                    return $order_status_html;
                })
                ->addColumn('dealer_name', function($order){
                    return User::where('id',$order->user_id)->value('first_name')." ".User::where('id',$order->user_id)->value('last_name');

                })
                /*->filter(function ($instance) use ($request) {

                    if ($request->get('order_status')) {
                        $instance->where('order_items.status', $request->get('order_status'));
                    }
                        
                })*/
                
                // ->filter(function ($instance) use ($request) {
                //     if ($request->get('order_status')) {
                //         $instance->where('order_items.status', $request->get('order_status'));
                //     }


                //     if (!empty($request->get('search'))) {
                //         $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                //             if (Str::contains(Str::lower($row['name']), Str::lower($request->get('search')))){
                //                 return true;
                //             }else if (Str::contains(Str::lower($row['name']), Str::lower($request->get('search')))) {
                //                 return true;
                //             }
                //             return false;
                //         });
                //     }
                // })
                ->rawColumns(['schduled_date1','shipping_date1','action','order_status'])
                ->make(true);
        }

    }


     function get_itemname($item_id){
            return Item::where('id',$item_id)->value('name');
    }

    
}