<?php 
namespace App\Http\Controllers;
    
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\Pattern;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use Spatie\Permission\Traits\HasRoles;
use Mail;
use DataTables;
use Auth;

class PatternController extends Controller
{
    public function index()
    {   
        $foam = Pattern::orderBy('id','DESC')->get();
       return view('pages.pattern.index',compact('foam'));;
    }

    public function create()
    {
        return view('pages.pattern.create');
    }

    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'       => 'required',
          //  'price'            => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $dealer = new Pattern;
        $dealer->name = $request->name;
       // $dealer->price  = $request->price;
        $dealer->save();
        return redirect('pattern')->with('message', 'Pattern created successfully');
    }

    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function show($id)
    {
        //
    }

    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */
    public function edit($id)
    {
        $dealer = Pattern::find($id);
        return view('pages.pattern.edit',compact('dealer'));
    }

    /**
        * Update the specified resource in storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function update(Request $request, $id)
    {
            $validator = Validator::make($request->all(), [
                'name'       => 'required',
               // 'price'            => 'required',
            ]);
        

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $dealer = Pattern::find($id);
        $dealer->name = $request->name;
       // $dealer->price  = $request->price;
        $dealer->save();
        return redirect('pattern')->with('message', 'Pattern updated successfully');
    }

    /**
        * Remove the specified resource from storage.
        *
        * @param  int  $id
        * @return Response
        */
    public function destroy($id)
    {
        $dealer = Pattern::find($id);
        $dealer->delete();
        return redirect('pattern')->with('message', 'Pattern deleted successfully');
    }



}