<?php 

namespace App\Http\Controllers;
use App\DataTables\UsersDataTable;
   
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\ProductCategory;
use App\Models\Product;
use App\Models\Foam_Style;
use App\Models\Item;
use App\Models\Foam_Grade;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use DataTables;
use App\Models\{Country,State,City};

class PillowsController extends Controller
{
    public function index()
    {   
        $pillows = Product::OrderBy('id','DESC')->where('product_cat_id',9)->get();
        return view('pages.products.pillows.index',compact('pillows'));
    }

    /**
        * Show the form for creating a new resource.
        *
        * @return Response
    */

    public function create()
    {
        return view('pages.products.pillows.create');
    }

    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'             => 'required',
            'fabric_required'  => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $pillow = new Product;
        $pillow->product_cat_id   = 9;
        $pillow->name             = $request->name;
        $pillow->price             = $request->price;
        $pillow->fabric_required  = $request->fabric_required;
        $pillow->save();
        return redirect('pillows')->with('message', 'Pillow has been created successfully');
    }

    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function show($id)
    {
        $products = Product::find($id);
        return view('pages.products.pillows.show',compact('products'));
    }

    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function edit($id)
    {
        $products    = Product::find($id);
        return view('pages.products.pillows.edit',compact('products'));
    }

    /**
        * Update the specified resource in storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'name'             => 'required',
            'fabric_required'  => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $pillow = Product::find($id);
        $pillow->name             = $request->name;
        $pillow->price             = $request->price;
        $pillow->fabric_required  = $request->fabric_required;
        $pillow->save();
        return redirect('pillows')->with('message', 'Pillow has been updated successfully');
    }

    /**
        * Remove the specified resource from storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function destroy($id)
    {
        $product = Product::find($id);
        $product->delete();
        return redirect('pillows')->with('message', 'Pillow has been deleted successfully');
    }


}