<?php 

namespace App\Http\Controllers;
use App\DataTables\UsersDataTable;
   
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\ProductCategory;
use App\Models\Product;
use App\Models\Foam_Style;
use App\Models\Item;
use App\Models\Foam_Grade;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use DataTables;
use App\Models\{Country,State,City};

class SectionalController extends Controller
{
    public function index()
    {   
        $sectional = Product::OrderBy('id','DESC')->where('product_cat_id',8)->get();
        return view('pages.products.sectional.index',compact('sectional'));
    }

    /**
        * Show the form for creating a new resource.
        *
        * @return Response
    */

    public function create()
    {
        $mechanism = Item::where('item_cat_id',5)->orderBy('name','ASC')->get();
        $foam_styles = DB::table('item')
            ->select('item.id','products.name')
            ->join('products','products.id','=','item.style')
            ->where(['item.item_cat_id' => '2'])->orderBy('name','ASC')->get();
        $lags        = Item::where('item_cat_id',3)->orderBy('name','ASC')->get();
        $foam_grades = Foam_Grade::orderBy('name','ASC')->get();
        $nail_heads  = Item::where('item_cat_id',4)->orderBy('name','ASC')->get();
                $pillow  = Product::where('product_cat_id',9)->orderBy('name','ASC')->get();
        $fabric = Item::where('item_cat_id',1)->orderBy('name','ASC')->get();
        return view('pages.products.sectional.create',compact('foam_styles', 'lags', 'mechanism','foam_grades', 'nail_heads','pillow','fabric'));
    }

    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'             => 'required',
            'fabric_required'  => 'required',
            'foam_count'       => 'required',
            'mechanism'       => 'required',
            //'pillow_quantity'       => 'required|numeric',
            //'pillow_fabric_item_id'       => 'required|numeric',
            //'pillow_fabric_required'       => 'required|numeric',
            //'pillow_product_id'       => 'required|numeric',
            //'foam_style'       => 'required',
            'legs'             => 'required',
            'legs_req'        => 'required|numeric',
            //'foam_grade'       => 'required',
            'nail_head'        => 'required',
            //'tufting'          => 'required',
            'image'            => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $sectional = new Product;
        $sectional->product_cat_id   = 8;
        $sectional->mechanism_id       = $request->mechanism;
        $sectional->name             = $request->name;
        $sectional->fabric_required  = $request->fabric_required;
        $sectional->foam_count       = $request->foam_count;
        //$sectional->foam_style_id    = $request->foam_style;
        //$sectional->pillow_quantity  = $request->pillow_quantity;
        // $sectional->pillow_fabric_item_id  = $request->pillow_fabric_item_id;
        // $sectional->pillow_fabric_required  = $request->pillow_fabric_required;
        //$sectional->pillow_product_id  = $request->pillow_product_id;


        if(isset($request->price)){
            $sectional->price        = $request->price;  
        }

        if(!$request->is_pillow_req){
        $sectional->pillow_quantity  = $request->pillow_quantity;
        $sectional->pillow_product_id  = $request->pillow_product_id;
        $sectional->is_pil_not_req    = 0;
        }  else {
        $sectional->is_pil_not_req    = 1;
        }

        $sectional->legs             = $request->legs;
        $sectional->legs_req         = $request->legs_req;
        $sectional->foam_grade_id    = $request->foam_grade;
        $sectional->nail_head        = $request->nail_head;
        $sectional->tufting          = $request->tufting;
        $sectional->notes            = $request->notes;
        //upload image
        if($request->hasfile('image'))
        {
            $image = $request->file('image');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/item/fabric/');
            $image->move($destinationPath, $name);
            $sectional->image = $name;
        }
        $sectional->save();
        return redirect('sectional')->with('message', 'Product Sectional has been created successfully');
    }

    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function show($id)
    {
        $products = Product::find($id);
        return view('pages.products.sectional.show',compact('products'));
    }

    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function edit($id)
    {
        $mechanism = Item::where('item_cat_id',5)->orderBy('name','ASC')->get();
        $products    = Product::find($id);
        $foam_styles = DB::table('item')
                        ->select('item.id','products.name')
                        ->join('products','products.id','=','item.style')
                        ->where(['item.item_cat_id' => '2'])->orderBy('name','ASC')->get();
        $lags        = Item::where('item_cat_id',3)->orderBy('name','ASC')->get();
        $foam_grades = Foam_Grade::orderBy('name','ASC')->get();
        $nail_heads  = Item::where('item_cat_id',4)->orderBy('name','ASC')->get();
                        $pillow  = Product::where('product_cat_id',9)->orderBy('name','ASC')->get();
        $fabric = Item::where('item_cat_id',1)->orderBy('name','ASC')->get();
        return view('pages.products.sectional.edit',compact('products','foam_styles','lags','foam_grades','nail_heads','mechanism','pillow','fabric'));
    }

    /**
        * Update the specified resource in storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'name'             => 'required',
            'fabric_required'  => 'required',
            'foam_count'       => 'required',
            'mechanism'     => 'required',
            //'pillow_quantity'       => 'required|numeric',
            // 'pillow_fabric_item_id'       => 'required|numeric',
            // 'pillow_fabric_required'       => 'required|numeric',
            //'pillow_product_id'       => 'required|numeric',
            //'foam_style'       => 'required',
            //'price'            => 'required',
            'legs'             => 'required',
            'legs_req'        => 'required|numeric',
            'foam_grade'       => 'required',
            'nail_head'        => 'required',
            //'tufting'          => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $sectional = Product::find($id);
        $sectional->product_cat_id   = 8;
        $sectional->name             = $request->name;
        $sectional->mechanism_id       = $request->mechanism;
        //$sectional->pillow_quantity  = $request->pillow_quantity;
        // $sectional->pillow_fabric_item_id  = $request->pillow_fabric_item_id;
        // $sectional->pillow_fabric_required  = $request->pillow_fabric_required;
        //$sectional->pillow_product_id  = $request->pillow_product_id;

        if(!$request->is_pillow_req){
        $sectional->pillow_quantity  = $request->pillow_quantity;
        $sectional->pillow_product_id  = $request->pillow_product_id;
        $sectional->is_pil_not_req    = 0;
        }  else {
        $sectional->is_pil_not_req    = 1;
        }

        $sectional->fabric_required  = $request->fabric_required;
        $sectional->foam_count       = $request->foam_count;
        //$sectional->foam_style_id    = $request->foam_style;
        $sectional->price            = $request->price;
        $sectional->legs             = $request->legs;
        $sectional->legs_req         = $request->legs_req;
        $sectional->foam_grade_id    = $request->foam_grade;
        $sectional->nail_head        = $request->nail_head;
        $sectional->tufting          = $request->tufting;
        $sectional->notes            = $request->notes;
        //upload image
        if($request->hasfile('image'))
        {
            $image = $request->file('image');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/item/fabric/');
            $image->move($destinationPath, $name);
            $sectional->image = $name;
        }
        $sectional->save();
        return redirect('sectional')->with('message', 'Product Sectional has been updated successfully');
    }

    /**
        * Remove the specified resource from storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function destroy($id)
    {
        $product = Product::find($id);
        $product->delete();
        return redirect('sectional')->with('message', 'Product Sectional has been deleted successfully');
    }

    public function import_csv()
    {   
       return view('pages.products.sectional.import-csv');
    }

    public function importFabric(Request $request)
    {   
        $validator = Validator::make($request->all(), [
            'csv_file' => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }
        $file = $request->file('csv_file');

      // File Details 
      $filename = time().rand().'.'.$file->getClientOriginalExtension(); 
      $extension = $file->getClientOriginalExtension();
      $tempPath = $file->getRealPath();
      $fileSize = $file->getSize();
      $mimeType = $file->getMimeType();

      // Valid File Extensions
      $valid_extension = array("csv");

      // 2MB in Bytes
      $maxFileSize = 2097152; 

      // Check file extension
      if(in_array(strtolower($extension),$valid_extension)){

        // Check file size
        if($fileSize <= $maxFileSize){

          // File upload location
          //$location = 'uploads';
          $location = public_path('/item/uploads');

          // Upload file
          $file->move($location,$filename);

          // Import CSV to Database
          $filepath = public_path('/item/uploads'."/".$filename);

          // Reading file
          $file = fopen($filepath,"r");

          $importData_arr = array();
          $i = 0;

          while (($filedata = fgetcsv($file, 1000, ",")) !== FALSE) {
             $num = count($filedata );
             
             // Skip first row (Remove below comment if you want to skip the first row)
             /*if($i == 0){
                $i++;
                continue; 
             }*/
             for ($c=0; $c < $num; $c++) {
                $importData_arr[$i][] = $filedata [$c];
             }
             $i++;
          }
          fclose($file);

          // Insert to MySQL database
          foreach($importData_arr as $key => $importData){
            if($key == 0){
            }else{
                $content = file_get_contents($importData[12]);
                $name    = time().rand();
                $destinationPath = public_path('/item/fabric/');
                file_put_contents($destinationPath.$name.".jpg", $content);

                $image_name = $name.".jpg";

                $insertData = array(
               "name"=>                   $importData[0],
               "fabric_required"=>        $importData[1],
               "foam_count"=>             $importData[2],
               "nail_head"=>              $importData[3],
               "price"=>                  $importData[4],
               "legs"=>                   $importData[5],
               "pillow_product_id"=>      $importData[6],
               "pillow_quantity"=>        $importData[7],
               "foam_grade_id"=>          $importData[8],
               "mechanism_id"=>           $importData[9],               
               "tufting"=>                $importData[10],
               "notes"    =>              $importData[11],
               'image'    => $image_name,
               "product_cat_id"=>           8);     
                Product::insert($insertData);
            }
            
          }
          return redirect('sectional')->with('message', 'Sectional Imported successfully');
        }else{
          return redirect('sectional-import-csv')->with('message', 'File too large. File must be less than 2MB.');
        }

      }else{
         return redirect('sectional-import-csv')->with('message', 'Invalid File Extension');
      }

    }

}