<?php 

namespace App\Http\Controllers;
use App\DataTables\UsersDataTable;
   
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\ProductCategory;
use App\Models\Product;
use App\Models\Foam_Style;
use App\Models\Item;
use App\Models\Foam_Grade;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use DataTables;
use App\Models\{Country,State,City};

class SofabedController extends Controller
{
    public function index()
    {   
        $sofabed = Product::OrderBy('id','DESC')->where('product_cat_id',5)->get();
        return view('pages.products.sofabed.index',compact('sofabed'));
    }

    /**
        * Show the form for creating a new resource.
        *
        * @return Response
    */

    public function create()
    {
        $mechanism = Item::where('item_cat_id',5)->orderBy('name','ASC')->get();
        $foam_styles = DB::table('item')
            ->select('item.id','products.name')
            ->join('products','products.id','=','item.style')
            ->where(['item.item_cat_id' => '2'])->orderBy('name','ASC')->get();
        $lags        = Item::where('item_cat_id',3)->orderBy('name','ASC')->get();
        $foam_grades = Foam_Grade::orderBy('name','ASC')->get();
        $nail_heads  = Item::where('item_cat_id',4)->orderBy('name','ASC')->get();
        $pillow  = Product::where('product_cat_id',9)->orderBy('name','ASC')->get();
        $fabric = Item::where('item_cat_id',1)->orderBy('name','ASC')->get();
        return view('pages.products.sofabed.create',compact('mechanism','foam_styles', 'lags', 'foam_grades', 'nail_heads','pillow','fabric'));
    }

    /**
        * Store a newly created resource in storage.
        *
        * @return Response
    */
    public function store(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name'             => 'required',
            'fabric_required'  => 'required',
            'foam_count'       => 'required',
            'mechanism'       => 'required',
            //'pillow_quantity'       => 'required|numeric',
            // 'pillow_fabric_item_id'       => 'required|numeric',
            // 'pillow_fabric_required'       => 'required|numeric',
            //'pillow_product_id'       => 'required|numeric',
            //'foam_style'       => 'required',
            'legs'             => 'required',
            'legs_req'        => 'required|numeric',
            //'foam_grade'       => 'required',
            'nail_head'        => 'required',
            //'tufting'          => 'required',
            'image'            => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $sofabed = new Product;
        $sofabed->product_cat_id   = 5;
        $sofabed->name             = $request->name;
        $sofabed->mechanism_id     = $request->mechanism;
        $sofabed->fabric_required  = $request->fabric_required;
        $sofabed->foam_count       = $request->foam_count;
        //$sofabed->foam_style_id    = $request->foam_style;
        //$sofabed->pillow_quantity  = $request->pillow_quantity;
        // $sofabed->pillow_fabric_item_id  = $request->pillow_fabric_item_id;
        // $sofabed->pillow_fabric_required  = $request->pillow_fabric_required;
        //$sofabed->pillow_product_id  = $request->pillow_product_id;

        if(!$request->is_pillow_req){
        $sofabed->pillow_quantity  = $request->pillow_quantity;
        $sofabed->pillow_product_id  = $request->pillow_product_id;
        $sofabed->is_pil_not_req    = 0;
        }  else {
        $sofabed->is_pil_not_req    = 1;
        }

        if(isset($request->price)){
            $sofabed->price        = $request->price;  
        }
        $sofabed->legs             = $request->legs;
        $sofabed->legs_req         = $request->legs_req;
        $sofabed->foam_grade_id    = $request->foam_grade;
        $sofabed->nail_head        = $request->nail_head;
        $sofabed->tufting          = $request->tufting;
        $sofabed->notes            = $request->notes;
        //upload image
        if($request->hasfile('image'))
        {
            $image = $request->file('image');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/item/fabric/');
            $image->move($destinationPath, $name);
            $sofabed->image = $name;
        }
        $sofabed->save();
        return redirect('sofabed')->with('message', 'Product Sofabed has been created successfully');
    }

    /**
        * Display the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function show($id)
    {
        $products = Product::find($id);
        return view('pages.products.sofabed.show',compact('products'));
    }

    /**
        * Show the form for editing the specified resource.
        *
        * @param  int  $id
        * @return Response
    */

    public function edit($id)
    {
        $mechanism = Item::where('item_cat_id',5)->get();
        $products    = Product::find($id);
        $foam_styles = DB::table('item')
            ->select('item.id','products.name')
            ->join('products','products.id','=','item.style')
            ->where(['item.item_cat_id' => '2'])->orderBy('id','DESC')->get();
        $lags        = Item::where('item_cat_id',3)->orderBy('id','DESC')->get();
        $foam_grades = Foam_Grade::orderBy('id','DESC')->get();
        $nail_heads  = Item::where('item_cat_id',4)->orderBy('id','DESC')->get();
        $pillow  = Product::where('product_cat_id',9)->get();
        $fabric = Item::where('item_cat_id',1)->orderBy('id','DESC')->get();
        return view('pages.products.sofabed.edit',compact('products','foam_styles','lags','foam_grades','nail_heads','mechanism','pillow','fabric'));
    }

    /**
        * Update the specified resource in storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'name'             => 'required',
            'fabric_required'  => 'required',
            'foam_count'       => 'required',
            'mechanism'       => 'required',
            //'pillow_quantity'       => 'required|numeric',
            // 'pillow_fabric_item_id'       => 'required|numeric',
            // 'pillow_fabric_required'       => 'required|numeric',
            //'pillow_product_id'       => 'required|numeric',
            //'foam_style'       => 'required',
            //'price'            => 'required',
            'legs'             => 'required',
            'legs_req'        => 'required|numeric',
            //'foam_grade'       => 'required',
            'nail_head'        => 'required',
            //'tufting'          => 'required',
        ]);

        if ($validator->fails()){
            return redirect()->back()->withErrors($validator)->withInput();
        }

        $sofabed = Product::find($id);
        $sofabed->product_cat_id   = 5;
        $sofabed->name             = $request->name;
        $sofabed->mechanism_id     = $request->mechanism;
        $sofabed->fabric_required  = $request->fabric_required;
        $sofabed->foam_count       = $request->foam_count;
        //$sofabed->pillow_quantity  = $request->pillow_quantity;
        // $sofabed->pillow_fabric_item_id  = $request->pillow_fabric_item_id;
        // $sofabed->pillow_fabric_required  = $request->pillow_fabric_required;
        //$sofabed->pillow_product_id  = $request->pillow_product_id;
        //$sofabed->foam_style_id    = $request->foam_style;
        if(!$request->is_pillow_req){
        $sofabed->pillow_quantity  = $request->pillow_quantity;
        $sofabed->pillow_product_id  = $request->pillow_product_id;
        $sofabed->is_pil_not_req    = 0;
        }  else {
        $sofabed->is_pil_not_req    = 1;
        $sofabed->pillow_quantity  = 0;
        $sofabed->pillow_product_id  = 0;
        }
        $sofabed->price            = $request->price;
        $sofabed->legs             = $request->legs;
        $sofabed->legs_req         = $request->legs_req;
        $sofabed->foam_grade_id    = $request->foam_grade;
        $sofabed->nail_head        = $request->nail_head;
        $sofabed->tufting          = $request->tufting;
        $sofabed->notes            = $request->notes;
        //upload image
        if($request->hasfile('image'))
        {
            $image = $request->file('image');
            $name = time().rand().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/item/fabric/');
            $image->move($destinationPath, $name);
            $sofabed->image = $name;
        }
        $sofabed->save();
        return redirect('sofabed')->with('message', 'Product Sofabed has been updated successfully');
    }

    /**
        * Remove the specified resource from storage.
        *
        * @param  int  $id
        * @return Response
    */

    public function destroy($id)
    {
        $product = Product::find($id);
        $product->delete();
        return redirect('sofabed')->with('message', 'Product Sofabed has been deleted successfully');
    }


}