<?php 

namespace App\Http\Controllers;
use App\DataTables\UsersDataTable;
   
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use App\Models\ProductCategory;
use App\Models\Product;
use Auth;
use App\Models\Stock_History;
use App\Models\Foam_Style;
use App\Models\Order;
use App\Models\Order_Item;
use App\Models\Item;
use App\Models\Foam_Grade;
use Spatie\Permission\Models\Role;
use Session;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use DataTables;
use App\Models\{Country,State,City};
//cart
use Overtrue\LaravelShoppingCart\Cart;

class StockController extends Controller
{ 

	public function index()
    {         
    
    	$item_cat = DB::table('item_category')->OrderBy('name','ASC')->get();

        return view('pages.stock.index',compact('item_cat'));
    	
    }

	public function getitemstock(Request $request)
    {         

        if($request->item_id != 2){
        $item = Item::where('item_cat_id',$request->item_id);

             if($request->item_id != 1){
             $items = $item->where('is_available','yes')->OrderBy('name','ASC')->get();
             } else {
             $items = $item->where('is_available','0')->OrderBy('name','ASC')->get();
             }

        } else {
        $items = Item::join('products','products.id','=','item.style')->leftjoin('foam_grade','item.fabric_grade_id','=','foam_grade.id')->where('item_cat_id',$request->item_id)->select('item.*','products.name as name','foam_grade.name as grade_name')->distinct('foam_grade.id')->where('is_available','yes')->OrderBy('products.name','ASC')->get();


        } 

    	foreach($items as $item){
    		$item->enc_id = base64_encode($item->id);
    	}

        return $items;
    }


    public function show(Request $request)
    {         

        if($request->item_id != 2){
        $item = Item::where('item_cat_id',$request->item_id);

             if($request->item_id != 1){
             $items = $item->where('is_available','yes')->get();
             } else {
             $items = $item->where('is_available','0')->get();
             }

        } else {
        $items = Item::join('products','products.id','=','item.style')->leftjoin('foam_grade','item.fabric_grade_id','=','foam_grade.id')->where('item_cat_id',$request->item_id)->select('item.*','products.name as name','foam_grade.name as grade_name')->distinct('foam_grade.id')->where('is_available','yes')->get();

        //$items = Foam_Grade::leftjoin('products','products.foam_grade_id','=','foam_grade.id')->join('item','products.id','=','item.style')->where('item_cat_id',$request->item_id)->select('item.*','products.name as name','foam_grade.name as grade_name')->groupBy('item.id','products.id','foam_grade.id')->get();

        } 

        foreach($items as $item){
            $item->enc_id = base64_encode($item->id);
        }

        return $items;
    }

	public function getproductstock(Request $request)
    {         

    	$items = Product::leftjoin('foam_grade','products.foam_grade_id','=','foam_grade.id')->where('products.product_cat_id',$request->item_id)->select('products.*','foam_grade.name as grade_name')->OrderBy('grade_name','ASC')->get();
        return $items;
    }

	public function viewhistory($id)
    {         
    	$id = base64_decode($id);
    	$items = Stock_History::where('item_id',$id)
    			->join('item','item.id','=','stock_history.item_id')->OrderBy('item.name','ASC')->get();
         return view('pages.stock.history',compact('items'));
    }

	public function store(Request $request)
    {         

    	//return $request;
    	$item = Item::where('id',$request->style)->first();
    	if($item){
    	

    	
    	$stock =new  Stock_History;
    	$stock->item_id = $item->id;
    	$stock->type = "Item";
    	$stock->stock_added = $request->added_qty;
    	$stock->user_id = Auth::user()->id;
    	$stock->stock_avl = $item->quantity_available;
    	$stock->save();

        $item->quantity_available = $item->quantity_available + $request->added_qty;
        $item->save();

    	return redirect()->back()->with('message', 'Stock Added successfully.');


    	}
        //return $request;
    }

	public function store_prod(Request $request)
    {         

    	$item = Product::where('id',$request->order_item)->first();
    	$item->quantity_available = $item->quantity_available + $request->added_qty;
    	$item->save();

    	if($item){
    	$stock =new  Stock_History;
    	$stock->item_id = $item->id;
    	$stock->type = "Item";
    	$stock->stock_added = $request->added_qty;
    	$stock->user_id = Auth::user()->id;
    	$stock->stock_avl = $item->quantity_available;
    	$stock->save();

    	return redirect()->back()->with('message', 'Stock Added successfully.');


    	}
        //return $request;
    }



}