<?php

namespace App\Http\Controllers;

use App\DataTables\UsersDataTable;
use Illuminate\Routing\UrlGenerator;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Response;
use App\Models\Stock_History;
use App\Models\ProductCategory;
use App\Models\Product;
use App\Models\Foam_Style;
use App\Models\Order;
use App\Models\Order_Item;
use App\Models\Item;
use App\Models\Foam_Grade;
use Spatie\Permission\Models\Role;
use Session;
use Auth;
use Illuminate\Support\Facades\Validator;
use DB;
use Hash;
use Illuminate\Support\Arr;
use DataTables;
use App\Models\{Country,State,City};
//cart
use Overtrue\LaravelShoppingCart\Cart;
use Mail;
use Illuminate\Support\Str;

class StudentController extends Controller
{
    public function index()
    {
        
        return view('welcome');
    }

    public function exportCsv(Request $request)
   {
   $fileName = 'orders.csv';
   $tasks = Order::where('orders.status',1)->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->leftjoin('users','users.id','=','orders.user_id')->select('order_items.id as order_det_id','orders.id as order_id','orders.user_id as user_id','order_items.total_price as total_price','orders.po_number as po_number','order_items.status as status','order_items.order_date','products.name','item.name as fabric_name','orders.billing_address','orders.billing_city','orders.billing_provience','orders.billing_country','orders.billing_pincode','orders.shipping_address','orders.shipping_city','orders.shipping_provience','orders.shipping_country','orders.shipping_pincode','order_items.*','users.email','users.first_name','users.last_name');

            if($request->get('status') >= 0 && $request->get('status') != '')
            {
                //return $request->status;
               $tasks->where('order_items.status',$request->status);  
            }

                if($request->get('search')){
                
                $search = $request->get('search');
                
                $tasks = $tasks->where('users.first_name', 'like', '%'.$search.'%')->orWhere('users.last_name', 'like', '%'.$search.'%')->orWhere('products.name', 'like', '%'.$search.'%')->orWhere('order_items.order_date', 'like', '%'.$search.'%')->orWhere('orders.po_number', 'like', '%'.$search.'%')->orWhere('order_items.schduled_date', 'like', '%'.$search.'%')->orWhere('order_items.shipping_date', 'like', '%'.$search.'%');
                            
            }

         $tasks = $tasks->orderBy('order_items.id', "desc")->get();

         //return $tasks;

        $headers = array(
            "Content-type"        => "text/csv",
            "Content-Disposition" => "attachment; filename=$fileName",
            "Pragma"              => "no-cache",
            "Cache-Control"       => "must-revalidate, post-check=0, pre-check=0",
            "Expires"             => "0"
        );

        $columns = array('PO Number','Order Date', 'Dealer Name', 'Product Name', 'Fabric', 'Status', 'Email', 'Billing Address','Billing City','Billing Provience','Billing Country','Billing Pincode','Shipping Address','Shipping City','Shipping Provience','Shipping Country','Shipping Pincode','Fabric Required','Tufting','Legs','Nailhead','Foam Style','Foam Quantity','Mechanism','Foam Grade','Pillow Fabric','Pillow Style','Pillow Quantity','Pillow Fabric Yard Req','Price','Tax','Schduled Date','Total Price','Shipping Date','Order Description');

        $callback = function() use($tasks, $columns) {
            $file = fopen('php://output', 'w');
            fputcsv($file, $columns);
            foreach ($tasks as $order) {
                // $dealer_name = User::where('id',$order->user_id)->value('first_name')." ".User::where('id',$order->user_id)->value('last_name');
                if($order->status ==0){
                    $status = "Back Order";
                }
                elseif($order->status ==1){
                    $status = "Order Received";
                }
                elseif($order->status ==2){
                    $status = "Manufacturing";
                }
                elseif($order->status ==3){
                    $status = "Ready To Ship";
                }
                else{
                    $status = "Shipped";
                }

                // $email              = User::where('id',$order->user_id)->value('email');
                $billing_city       = City::where('id',$order->billing_city)->value('name');
                $billing_provience  = State::where('id',$order->billing_provience)->value('name');
                $billing_country    = Country::where('id',$order->billing_country)->value('name');
                $shipping_city      = City::where('id',$order->shipping_city)->value('name');
                $shipping_provience = State::where('id',$order->shipping_provience)->value('name');
                $shipping_country   = Country::where('id',$order->shipping_country)->value('name');
                $foam_grade         = Foam_Grade::where('id',$order->foam_style_id)->value('name');
                $pillow_fabric      = Item::where('id',$order->pillow_fabric)->value('name');
                $pillow_style       = Product::where('id',$order->pillow_style)->value('name');
                    
                $row['po_number']     = $order->po_number;
                $row['order_date']    = $order->order_date;
                $row['dealer_name']   = $order->first_name.' '.$order->last_name;
                $row['name']          = $order->name;
                $row['fabric_name']   = $order->fabric_name;
                $row['status']        = $status;
                $row['email']         = $order->email;
                $row['billing_address']    = $order->billing_address;
                $row['billing_city']       = $billing_city;
                $row['billing_provience']  = $billing_provience;
                $row['billing_country']    = $billing_country;
                $row['billing_pincode']    = $order->billing_pincode;
                $row['shipping_address']    = $order->shipping_address;
                $row['shipping_city']       = $shipping_city;
                $row['shipping_provience']  = $shipping_provience;
                $row['shipping_country']    = $shipping_country;
                $row['shipping_pincode']    = $order->shipping_pincode;
                $row['fabric_required']    = $order->fabric_required;
                $row['tufting']            = $order->tufting;
                $row['leg_id']             = $this->get_itemname($order->leg_id);
                $row['nailhead_id']        = $this->get_itemname($order->nailhead_id);
                $row['foam_style_id']    = $this->get_itemname($order->foam_style_id);
                $row['foam_qty']    = $order->foam_qty;
                $row['mechanism_id']       = $this->get_itemname($order->mechanism_id);
                $row['foam_grade']  = $foam_grade;
                $row['pillow_fabric']    = $pillow_fabric;
                $row['pillow_style']    = $pillow_style;
                $row['pillow_qty']    = $order->pillow_qty;
                $row['pillow_yard_req']       = $order->pillow_yard_req;
                $row['price']  = $order->price;
                $row['tax']    = $order->tax;
                $row['schduled_date']       = $order->schduled_date;
                $row['total_price']  = $order->total_price;
                $row['shipping_date']    = $order->shipping_date;
                $row['order_description']    = $order->order_description;

                fputcsv($file, array($row['po_number'], $row['order_date'], $row['dealer_name'], $row['name'], $row['fabric_name'], $row['status'], $row['email'], $row['billing_address'], $row['billing_city'], $row['billing_provience'], $row['billing_country'], $row['billing_pincode'], $row['shipping_address'], $row['shipping_city'], $row['shipping_provience'], $row['shipping_country'], $row['shipping_pincode'], $row['fabric_required'], $row['tufting'], $row['leg_id'], $row['nailhead_id'], $row['foam_style_id'], $row['foam_qty'], $row['mechanism_id'], $row['foam_grade'], $row['pillow_fabric'], $row['pillow_style'], $row['pillow_qty'], $row['pillow_yard_req'], $row['price'], $row['tax'], $row['schduled_date'], $row['total_price'], $row['shipping_date'], $row['order_description']));
                }

            fclose($file);
        };

        return response()->stream($callback, 200, $headers);
    }


    public function getStudents(Request $request)
    {
        
        if ($request->ajax()) {
            $order_status = '';
            //$search = '';
            $orders = Order::where('orders.status',1)->leftjoin('order_items','order_items.order_id','=','orders.id')->leftjoin('products','products.id','=','order_items.product_id')->leftjoin('item','item.id','=','order_items.fabric_id')->leftjoin('users','users.id','=','orders.user_id')->select('order_items.id as order_det_id','orders.id as order_id','orders.user_id as user_id','order_items.total_price as total_price','orders.po_number as po_number','order_items.status as status','order_items.order_date','order_items.schduled_date','order_items.shipping_date','products.name','item.name as fabric_name','orders.billing_address','orders.billing_city','orders.billing_provience','orders.billing_country','orders.billing_pincode','orders.shipping_address','orders.shipping_city','orders.shipping_provience','orders.shipping_country','orders.shipping_pincode','order_items.*');
            if($request->get('status_order')){
                $order_status = $request->get('status_order');
                if($order_status == '-1'){
                    $order_status = 0;
                }
                $orders = $orders->where('order_items.status',$order_status);
            }

            if($request->get('search')){
                
                $search = $request->get('search');
                if($search == '-1'){
                    $search = 0;
                }
                
                $orders = $orders->where('users.first_name', 'like', '%'.$search.'%')->orWhere('users.last_name', 'like', '%'.$search.'%')->orWhere('products.name', 'like', '%'.$search.'%')->orWhere('order_items.order_date', 'like', '%'.$search.'%')->orWhere('orders.po_number', 'like', '%'.$search.'%')->orWhere('order_items.schduled_date', 'like', '%'.$search.'%')->orWhere('order_items.shipping_date', 'like', '%'.$search.'%');
                            
            }

            $orders = $orders->orderBy('order_items.id', "desc")->get();
            return Datatables::of($orders)
                ->addIndexColumn()
                ->addColumn('action', function($row){
                    $action_html = '';
                    if($row->status < 3){
                        $action_html .= '<div class="menu-item px-3"><a href="'.url('edit')."/".$row->order_det_id.'" class="menu-link px-3"><i class="fas fa-edit"></i></a></div>';
                    }
                    $action_html .= '<div class="menu-item px-3">
                                        <a href="'.url('order-view')."/".base64_encode($row->order_id)."/".base64_encode($row->order_det_id).'" class="menu-link px-3"><i class="fa fa-eye"></i></a>
                                    </div>';  
                    if($row->status < 2){
                        $action_html .= '<div class="menu-item px-3"><a href="'.url('order-delete')."/".$row->order_det_id.'" class="menu-link px-3 delete-order" ><i class="fa fa-trash"></i>
                        </a></div>';
                    }
                    $action_html .= "</div>";   
                    return $action_html;
                })
                ->addColumn('schduled_date1', function($order){
                     
                     if($order->status < 3){
                     $order_schedule_html = $order->schduled_date.'<button class="schduled_date" data-id="'.$order->order_det_id.'"><i class="fa fa-pencil"></i> </button>';
                     return $order_schedule_html;
                 } else {
                    $order_schedule_html = $order->schduled_date;
                     return $order_schedule_html;
                 }

                })
                ->addColumn('shipping_date1', function($order){
                     
                     if($order->status < 3){
                     $order_schedule_html = $order->shipping_date.'<button class="shippingmodelbtn" data-id="'.$order->order_det_id.'"><i class="fa fa-pencil"></i></button>';
                     return $order_schedule_html;
                 } else {
                    $order_schedule_html = $order->shipping_date;
                     return $order_schedule_html;
                 }

                })
                ->addColumn('order_status', function($order){
                    $order_status_html = '';
                    $order_status_html .= '<select class="form-control order-status" item_id="'.$order->order_det_id.'">';

                    if($order->status ==0) {
                        $order_status_html .= '<option value="0" selected>Back Order</option>';
                    }else{

                        $order_status_html .= '<option value="0" disabled >Back Order</option>';
                    }

                    if($order->status ==1) {
                        $order_status_html .= '<option value="1" selected>Order Received</option>';
                    }else{
                        if($order->status > 1){
                        $order_status_html .= '<option value="1" disabled>Order Received</option>';
                        } else {
                         $order_status_html .= '<option value="1" >Order Received</option>';   
                        }
                    }

                    if($order->status ==2) {
                        $order_status_html .= '<option value="2" selected>Manufacturing</option>';
                    }else{
                        if($order->status > 2){
                        $order_status_html .= '<option value="2" disabled>Manufacturing </option>';
                        } else {
                        $order_status_html .= '<option value="2" >Manufacturing</option>';
                        }
                    }

                    if($order->status ==3) {
                        $order_status_html .= '<option value="3" selected>Ready To Ship</option>';
                    }else{
                        if($order->status > 3){
                        $order_status_html .= '<option value="3" disabled>Ready To Ship </option>';
                        } else {
                        $order_status_html .= '<option value="3">Ready To Ship</option>';
                        }
                    }

                    if($order->status ==4) {
                        $order_status_html .= '<option value="4"  selected>Shipped</option>';
                    }else{
                        $order_status_html .= '<option value="4" >Shipped</option>';
                    }

                    $order_status_html .= '</select>';  
                    return $order_status_html;
                })
                ->addColumn('dealer_name', function($order){
                    return User::where('id',$order->user_id)->value('first_name')." ".User::where('id',$order->user_id)->value('last_name');

                })
                /*->filter(function ($instance) use ($request) {

                    if ($request->get('order_status')) {
                        $instance->where('order_items.status', $request->get('order_status'));
                    }
                        
                })*/
                
                // ->filter(function ($instance) use ($request) {
                //     if ($request->get('order_status')) {
                //         $instance->where('order_items.status', $request->get('order_status'));
                //     }


                //     if (!empty($request->get('search'))) {
                //         $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                //             if (Str::contains(Str::lower($row['name']), Str::lower($request->get('search')))){
                //                 return true;
                //             }else if (Str::contains(Str::lower($row['name']), Str::lower($request->get('search')))) {
                //                 return true;
                //             }
                //             return false;
                //         });
                //     }
                // })
                ->rawColumns(['schduled_date1','shipping_date1','action','order_status'])
                ->make(true);
        }

    }

    function get_itemname($item_id){
            return Item::where('id',$item_id)->value('name');
    }
}